require 'sketchup' # First we pull in the standard API hooks.
require 'Practica//lib//utils.rb'
require 'Practica//lib//structures.rb'
require 'Practica//lib//m-structures.rb'
require 'Practica//lib//interfaces//custom.rb'

#With this method users can choose the shape that they wants.
def create_options (first=false)
	prompts = ["Elige una figura: "]
	default = ["Cubo "]
	list = ["Cubo |Prisma triangular |Prisma hexagonal"]
	input = UI.inputbox prompts, default, list, "Figuras"
	if input
		if input.include? "Cubo "
			prompts2 = ["Elija una regla: "]
			default2 = ["Cara "]
			list2 = ["Cara |Punto |Arista"]
			input2 = UI.inputbox prompts2, default2, list2, "Reglas"
			if input2
				if input2.include? "Cara "
					PracticaUtils.create_project_cube ("face")
				elsif input2.include? "Punto "
					PracticaUtils.create_project_cube ("point")
				elsif input2.include? "Arista"
					PracticaUtils.create_project_cube ("edge")
				end
			else
				PracticaUtils.create_project_cube ("face")
			end
		elsif input.include? "Prisma triangular "
			prompts2 = ["Elija una regla: "]
			default2 = ["Cara "]
			list2 = ["Cara |Cara girada |Punto |Punto girado |Arista |Arista girada 2 |Arista girada"]
			input2 = UI.inputbox prompts2, default2, list2, "Reglas"
			if input2
				if input2.include? "Cara "
					PracticaUtils.create_project_triangularprism ("face")
				elsif input2.include? "Cara girada "
					PracticaUtils.create_project_triangularprism ("face2")
				elsif input2.include? "Punto girado "
					PracticaUtils.create_project_triangularprism ("point2")
				elsif input2.include? "Punto "
					PracticaUtils.create_project_triangularprism ("point")
				elsif input2.include? "Arista girada"
					PracticaUtils.create_project_triangularprism ("edge2")
				elsif input2.include? "Arista girada 2 "
					PracticaUtils.create_project_triangularprism ("edge3")
				elsif input2.include? "Arista "
					PracticaUtils.create_project_triangularprism ("edge")
				end
			else
				PracticaUtils.create_project_triangularprism ("face")
			end
		elsif input.include? "Prisma hexagonal"
			prompts2 = ["Elija una regla: "]
			default2 = ["Cara "]
			list2 = ["Cara |Cara lateral |Arista"]
			input2 = UI.inputbox prompts2, default2, list2, "Reglas"
			if input2
				if input2.include? "Cara "
					PracticaUtils.create_project_hexagonalprism  ("face")
				elsif input2.include? "Cara lateral "
					PracticaUtils.create_project_hexagonalprism  ("face2")
				elsif input2.include? "Arista"
					PracticaUtils.create_project_hexagonalprism  ("edge")
				end
			else
				PracticaUtils.create_project_hexagonalprism  ("face")
			end
		else
			PracticaUtils.create_project_cube ("face")
		end
	else
		PracticaUtils.create_project_cube ("face")
	end
	execution = Practica.project.execution
	#We are goint to show the number of pieces
	execution.text.text = "Nmero de piezas = 1"
	execution.axiom = execution.current_shape.c[0]
end

#Method that creates the toolbar 
def create_static_toolbar()
	toolbar = UI.toolbar Constants::STATIC_TOOLBAR_NAME
	
	#Add Rule command
	add_rule_cmd = UI::Command.new("add_rule"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active

		size = execution.grammar.rules.size
		current_shape = PracticaUtils.current_shape()
		
		if (current_shape.type.include? "cube")
			prompts = ["Elija una regla: "]
			default = ["Cara "]
			list = ["Cara |Punto |Arista"]
			input = UI.inputbox prompts, default, list, "Reglas"
			if input
				if input.include? "Cara "
					if execution.grammar.search_rule_by_transformation("face")
						UI.messagebox("Ya tiene esa regla, pruebe otra")
					else
						shape = Cube.new(Constants::SIZE)
						#Obtain new rule id
						last_id = execution.grammar.rules[size-1].rule_id
			
						t_rule = Geom::Transformation.new
						t_rule = [shape.size,0,0]
						#Create new rule
						new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "face")
						execution.grammar.add_rule(new_rule)
					end
				elsif input.include? "Punto "
					if execution.grammar.search_rule_by_transformation("point")
						UI.messagebox("Ya tiene esa regla, pruebe otra")
					else
						shape = Cube.new(Constants::SIZE)
						#Obtain new rule id
						last_id = execution.grammar.rules[size-1].rule_id
						
						t_rule = Geom::Transformation.new
						t_rule = [shape.size,shape.size,-Constants::HEIGHT_S]
						#Create new rule
						new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "point")
						execution.grammar.add_rule(new_rule)
					end
				elsif input.include? "Arista"
					if execution.grammar.search_rule_by_transformation("edge")
						UI.messagebox("Ya tiene esa regla, pruebe otra")
					else
						shape = Cube.new(Constants::SIZE)
						#Obtain new rule id
						last_id = execution.grammar.rules[size-1].rule_id
			
						t_rule = Geom::Transformation.new
						t_rule = [shape.size,shape.size,0]
						#Create new rule
						new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "edge")
						execution.grammar.add_rule(new_rule)
					end
				end
			end
		elsif (current_shape.type.include? "triangle")
			prompts = ["Elija una regla: "]
			default = ["Cara "]
			list = ["Cara |Cara girada |Punto |Punto girado |Arista |Arista girada 2 |Arista girada"]
			input = UI.inputbox prompts, default, list, "Reglas"
			if input
				if input.include? "Cara "
					if execution.grammar.search_rule_by_transformation("face")
						UI.messagebox("Ya tiene esa regla, pruebe otra")
					else
						shape = TriangularPrism.new(Constants::SIZE)
						#Obtain new rule id
						last_id = execution.grammar.rules[size-1].rule_id
			
						t_rule = Geom::Transformation.new
						t_rule = [0,0,-Constants::HEIGHT_S]
						#Create new rule
						new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "face")
						execution.grammar.add_rule(new_rule)
					end
				elsif input.include? "Cara girada "
					if execution.grammar.search_rule_by_transformation("face2")
						UI.messagebox("Ya tiene esa regla, pruebe otra")
					else
						shape = TriangularPrism.new(Constants::SIZE)
						#Obtain new rule id
						last_id = execution.grammar.rules[size-1].rule_id
			
						t_rule = Geom::Transformation.new
						t_rule = [Constants::SIZE/2,Constants::HEIGHT_T,-Constants::HEIGHT_S] 
						#Create new rule
						new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "face2")
						execution.grammar.add_rule(new_rule)
					end
				elsif input.include? "Punto "
					if execution.grammar.search_rule_by_transformation("point")
						UI.messagebox("Ya tiene esa regla, pruebe otra")
					else
						shape = TriangularPrism.new(Constants::SIZE)
						#Obtain new rule id
						last_id = execution.grammar.rules[size-1].rule_id
						
						t_rule = Geom::Transformation.new
						t_rule = [Constants::SIZE,0,-Constants::HEIGHT_S] 
						#Create new rule
						new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "point")
						execution.grammar.add_rule(new_rule)
					end
				elsif input.include? "Punto girado "
					if execution.grammar.search_rule_by_transformation("point2")
						UI.messagebox("Ya tiene esa regla, pruebe otra")
					else
						shape = TriangularPrism.new(Constants::SIZE)
						#Obtain new rule id
						last_id = execution.grammar.rules[size-1].rule_id
						
						t_rule = Geom::Transformation.new
						t_rule = [Constants::SIZE,0,-2*Constants::HEIGHT_S] 
						#Create new rule
						new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "point2")
						execution.grammar.add_rule(new_rule)
					end
				elsif input.include? "Arista "
					if execution.grammar.search_rule_by_transformation("edge")
						UI.messagebox("Ya tiene esa regla, pruebe otra")
					else
						shape = TriangularPrism.new(Constants::SIZE)
						#Obtain new rule id
						last_id = execution.grammar.rules[size-1].rule_id
			
						t_rule = Geom::Transformation.new
						t_rule = [shape.size,0,0]
						#Create new rule
						new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "edge")
						execution.grammar.add_rule(new_rule)
					end
				elsif input.include? "Arista girada 2 "
					if execution.grammar.search_rule_by_transformation("edge3")
						UI.messagebox("Ya tiene esa regla, pruebe otra")
					else
						shape = TriangularPrism.new(Constants::SIZE)
						#Obtain new rule id
						last_id = execution.grammar.rules[size-1].rule_id
			
						t_rule = Geom::Transformation.new
						t_rule = [Constants::SIZE,0,-Constants::HEIGHT_S] 
						#Create new rule
						new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "edge3")
						execution.grammar.add_rule(new_rule)
					end
				elsif input.include? "Arista girada"
					if execution.grammar.search_rule_by_transformation("edge2")
						UI.messagebox("Ya tiene esa regla, pruebe otra")
					else
						shape = TriangularPrism.new(Constants::SIZE)
						#Obtain new rule id
						last_id = execution.grammar.rules[size-1].rule_id
			
						t_rule = Geom::Transformation.new
						t_rule = [Constants::SIZE/2,Constants::HEIGHT_T,-2*Constants::HEIGHT_S] 
						#Create new rule
						new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "edge2")
						execution.grammar.add_rule(new_rule)
					end
				end
			end
		elsif (current_shape.type.include? "hexagonal")
			prompts = ["Elija una regla: "]
			default = ["Cara "]
			list = ["Cara |Cara lateral |Arista"]
			input = UI.inputbox prompts, default, list, "Reglas"
			if input
				if input.include? "Cara "
					if execution.grammar.search_rule_by_transformation("face")
						UI.messagebox("Ya tiene esa regla, pruebe otra")
					else
						shape = HexagonalPrism.new(Constants::SIZE_H)
						#Obtain new rule id
						last_id = execution.grammar.rules[size-1].rule_id
			
						t_rule = Geom::Transformation.new
						t_rule = [0,0,-Constants::HEIGHT_S]
						#Create new rule
						new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "face")
						execution.grammar.add_rule(new_rule)
					end
				elsif input.include? "Cara lateral "
					if execution.grammar.search_rule_by_transformation("face2")
						UI.messagebox("Ya tiene esa regla, pruebe otra")
					else
						shape = HexagonalPrism.new(Constants::SIZE_H)
						#Obtain new rule id
						last_id = execution.grammar.rules[size-1].rule_id
			
						t_rule = Geom::Transformation.new
						t_rule = [shape.size+shape.size/2,-Constants::APOTEMA,0]
						#Create new rule
						new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "face2")
						execution.grammar.add_rule(new_rule)
					end
				elsif input.include? "Arista"
					if execution.grammar.search_rule_by_transformation("edge")
						UI.messagebox("Ya tiene esa regla, pruebe otra")
					else
						shape = HexagonalPrism.new(Constants::SIZE_H)
						#Obtain new rule id
						last_id = execution.grammar.rules[size-1].rule_id
			
						t_rule = Geom::Transformation.new
						t_rule = [shape.size+shape.size/2,-Constants::APOTEMA,-Constants::HEIGHT_S]
						#Create new rule
						new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "edge")
						execution.grammar.add_rule(new_rule)
					end
				end
			end
		end
	}
	add_rule_cmd.tooltip = "Aadir regla"
	add_rule_cmd.small_icon = File.join(Constants::ICONS_DIR, "add_rule.PNG")
	add_rule_cmd.large_icon = File.join(Constants::ICONS_DIR, "add_rule.PNG")
	toolbar.add_item add_rule_cmd
	
	#Add every Rule command
	add_everyrule_cmd = UI::Command.new("add_everyrule"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active

		size = execution.grammar.rules.size
		current_shape = PracticaUtils.current_shape()
		
		if (current_shape.type.include? "cube")
			if !execution.grammar.search_rule_by_transformation("face")
				shape = Cube.new(Constants::SIZE)
				#Obtain new rule id
				last_id = execution.grammar.rules[size-1].rule_id
				t_rule = Geom::Transformation.new
				t_rule = [shape.size,0,0]
				#Create new rule
				new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "face")
				execution.grammar.add_rule(new_rule)
				size+=1
			end
			if !execution.grammar.search_rule_by_transformation("point")
					shape = Cube.new(Constants::SIZE)
					#Obtain new rule id
					last_id = execution.grammar.rules[size-1].rule_id
					
					t_rule = Geom::Transformation.new
					t_rule = [shape.size,shape.size,-Constants::HEIGHT_S]
					#Create new rule
					new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "point")
					execution.grammar.add_rule(new_rule)
					size+=1
			end
			if !execution.grammar.search_rule_by_transformation("edge")
					shape = Cube.new(Constants::SIZE)
					#Obtain new rule id
					last_id = execution.grammar.rules[size-1].rule_id
					t_rule = Geom::Transformation.new
					t_rule = [shape.size,shape.size,0]
					#Create new rule
					new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "edge")
					execution.grammar.add_rule(new_rule)
					size+=1
			end
		elsif (current_shape.type.include? "triangle")
			if !execution.grammar.search_rule_by_transformation("face")
				shape = TriangularPrism.new(Constants::SIZE)
				#Obtain new rule id
				last_id = execution.grammar.rules[size-1].rule_id
				
				t_rule = Geom::Transformation.new
				t_rule = [0,0,-Constants::HEIGHT_S]
				#Create new rule
				new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "face")
				execution.grammar.add_rule(new_rule)
				size+=1
			end
			if !execution.grammar.search_rule_by_transformation("face2")
				shape = TriangularPrism.new(Constants::SIZE)
				#Obtain new rule id
				last_id = execution.grammar.rules[size-1].rule_id
				t_rule = Geom::Transformation.new
				t_rule = [Constants::SIZE/2,Constants::HEIGHT_T,-Constants::HEIGHT_S] 
				#Create new rule
				new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "face2")
				execution.grammar.add_rule(new_rule)
				size+=1
			end
			if !execution.grammar.search_rule_by_transformation("point")
				shape = TriangularPrism.new(Constants::SIZE)
				#Obtain new rule id
				last_id = execution.grammar.rules[size-1].rule_id
						
				t_rule = Geom::Transformation.new
				t_rule = [Constants::SIZE,0,-Constants::HEIGHT_S] 
				#Create new rule
				new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "point")
				execution.grammar.add_rule(new_rule)
				size+=1
			end
			if !execution.grammar.search_rule_by_transformation("point2")
				shape = TriangularPrism.new(Constants::SIZE)
				#Obtain new rule id
				last_id = execution.grammar.rules[size-1].rule_id
				
				t_rule = Geom::Transformation.new
				t_rule = [Constants::SIZE,0,-2*Constants::HEIGHT_S] 
				#Create new rule
				new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "point2")
				execution.grammar.add_rule(new_rule)
				size+=1
			end
			if !execution.grammar.search_rule_by_transformation("edge")
				shape = TriangularPrism.new(Constants::SIZE)
				#Obtain new rule id
				last_id = execution.grammar.rules[size-1].rule_id
				t_rule = Geom::Transformation.new
				t_rule = [shape.size,0,0]
				#Create new rule
				new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "edge")
				execution.grammar.add_rule(new_rule)
				size+=1
			end
			if !execution.grammar.search_rule_by_transformation("edge3")
				shape = TriangularPrism.new(Constants::SIZE)
				#Obtain new rule id
				last_id = execution.grammar.rules[size-1].rule_id
				t_rule = Geom::Transformation.new
				t_rule = [Constants::SIZE,0,-Constants::HEIGHT_S] 
				#Create new rule
				new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "edge3")
				execution.grammar.add_rule(new_rule)
				size+=1
			end
			if !execution.grammar.search_rule_by_transformation("edge2")
				shape = TriangularPrism.new(Constants::SIZE)
				#Obtain new rule id
				last_id = execution.grammar.rules[size-1].rule_id
				t_rule = Geom::Transformation.new
				t_rule = [Constants::SIZE/2,Constants::HEIGHT_T,-2*Constants::HEIGHT_S] 
				#Create new rule
				new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "edge2")
				execution.grammar.add_rule(new_rule)
				size+=1
			end
		elsif (current_shape.type.include? "hexagonal")
			if !execution.grammar.search_rule_by_transformation("face")
				shape = HexagonalPrism.new(Constants::SIZE_H)
				#Obtain new rule id
				last_id = execution.grammar.rules[size-1].rule_id
				t_rule = Geom::Transformation.new
				t_rule = [0,0,-Constants::HEIGHT_S]
				#Create new rule
				new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "face")
				execution.grammar.add_rule(new_rule)
				size+=1
			end
			if !execution.grammar.search_rule_by_transformation("face2")
				shape = HexagonalPrism.new(Constants::SIZE_H)
				#Obtain new rule id
				last_id = execution.grammar.rules[size-1].rule_id
				t_rule = Geom::Transformation.new
				t_rule = [shape.size+shape.size/2,-Constants::APOTEMA,0]
				#Create new rule
				new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "face2")
				execution.grammar.add_rule(new_rule)
				size+=1
			end
			if !execution.grammar.search_rule_by_transformation("edge")
				shape = HexagonalPrism.new(Constants::SIZE_H)
				#Obtain new rule id
				last_id = execution.grammar.rules[size-1].rule_id
				t_rule = Geom::Transformation.new
				t_rule = [shape.size+shape.size/2,-Constants::APOTEMA,-Constants::HEIGHT_S]
				#Create new rule
				new_rule = PracticaUtils.paint_rule(last_id+1, shape, t_rule, "edge")
				execution.grammar.add_rule(new_rule)
				size+=1
			end
		end
	}
	add_everyrule_cmd.tooltip = "Aadir todas las regla"
	add_everyrule_cmd.small_icon = File.join(Constants::ICONS_DIR, "add_everyrules.PNG")
	add_everyrule_cmd.large_icon = File.join(Constants::ICONS_DIR, "add_everyrules.PNG")
	toolbar.add_item add_everyrule_cmd
	
	#Delete Rule command
	delete_rule_cmd = UI::Command.new("delete_rule"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active

		if execution.grammar.rules.size > 1
			prompts = ["Elija la regla a borrar: "]
			default = ["1"]
			rule_list = PracticaUtils.create_rule_list()
			list = [rule_list]
			input = UI.inputbox prompts, default, list, "Borrar regla"
			if input
				chosen_rule_idx = input[0].to_i-1
				execution.grammar.delete_rule(chosen_rule_idx)
				# Transform the position of the rules from chosen_rule_idx
				idx = chosen_rule_idx
  
				while idx < execution.grammar.rules.size
					
					current_rule = execution.grammar.rules[idx]
					
					current_rule.shape.group.locked = false
					current_rule.shape.group.transform! Constants::DESCEND_T.inverse
					current_rule.shape.group.locked = true
					
					current_rule.group_arrow.locked = false
					current_rule.group_arrow.transform! Constants::DESCEND_T.inverse
					current_rule.group_arrow.locked = true
					
					current_rule.line_group.locked = false
					current_rule.line_group.transform! Constants::DESCEND_T.inverse
					current_rule.line_group.locked = true
						
					current_rule.shape_l.group.locked = false
					current_rule.shape_l.group.transform! Constants::DESCEND_T.inverse
					current_rule.shape_l.group.locked = true
					
					current_rule.shape_rule.group.locked = false
					current_rule.shape_rule.group.transform! Constants::DESCEND_T.inverse
					current_rule.shape_rule.group.locked = true
    
					idx += 1
				end
			end
		else
			UI.messagebox("No puede borrar todas las reglas")
		end
	}
	delete_rule_cmd.tooltip = "Borrar una regla"
	delete_rule_cmd.small_icon = File.join(Constants::ICONS_DIR, "delete_rule.PNG")
	delete_rule_cmd.large_icon = File.join(Constants::ICONS_DIR, "delete_rule.PNG")
	toolbar.add_item delete_rule_cmd
	
	toolbar.add_separator
	
	#Move the axiom
	move_seed_cmd = UI::Command.new("move_seed"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active
		shape = PracticaUtils.current_shape
		
		move_seed_tool = MoveSeedTool.new
		Sketchup.active_model.select_tool move_seed_tool
	}
	move_seed_cmd.tooltip = "Mover semilla"
	move_seed_cmd.small_icon = File.join(Constants::ICONS_DIR, "move_seed.PNG")
	move_seed_cmd.large_icon = File.join(Constants::ICONS_DIR, "move_seed.PNG")
	toolbar.add_item move_seed_cmd
	
	#Add seeds
	add_seed_cmd = UI::Command.new("add_seed"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active
		shape = PracticaUtils.current_shape
		
		add_seed_tool = AddSeedsTool.new
		Sketchup.active_model.select_tool add_seed_tool
	}
	add_seed_cmd.tooltip = "Aadir semillas"
	add_seed_cmd.small_icon = File.join(Constants::ICONS_DIR, "add_seed.PNG")
	add_seed_cmd.large_icon = File.join(Constants::ICONS_DIR, "add_seed.PNG")
	toolbar.add_item add_seed_cmd
	
	toolbar.add_separator
	
	# Execute command
	exe_cmd = UI::Command.new("apply_rule"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active

		selection = Sketchup.active_model.selection
		if !selection.empty?
			
			 # Look at all of the entities in the selection.
			current = PracticaUtils.current_shape
			current.c.sort! { |shape1, shape2|
				shape1.position <=> shape2.position
			}
			cont = 0
			max = current.c.length
			esta = false
			while (cont < max)&&(!esta)
				if current.type.include? "cube"
					if selection.contains? current.c[cont].cube.group
						esta = true
					end
					if !esta
						cont+=1
					end
				else
					if selection.contains? current.c[cont].prism.group
						esta = true
					end
					if !esta
						cont+=1
					end
				end
			end
			if esta
				prompts = ["Elija el id de una regla"]
				default = [1]
				rule_list = PracticaUtils.create_rule_list()
				list = [rule_list]
				input = UI.inputbox prompts, default, list, "Ejecutar regla"
				if input
					shape = PracticaUtils.current_shape
					chosen_rule_idx = input[0]
					chosen_rule_id = execution.grammar.rules[chosen_rule_idx.to_i - 1].rule_id
					exit = true
					if execution.up && execution.left
						if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
							exit = execution.backtracking_shape(chosen_rule_id, cont)
						else
							execution.num_steps.push(1)
							execution.apply_r_shape(chosen_rule_id, cont, current, false)
							execution.apply_r = true
						end
						if !exit
							UI.messagebox("No se pueden satisfacer las restricciones")
						else
							execution.apply_r = true
						end
					elsif execution.up
						rule = execution.grammar.search_rule_by_id(chosen_rule_id)
						if shape.type.include? "triangle"
							if rule.type_transformation == "face" || rule.type_transformation == "point" || rule.type_transformation == "point2" || rule.type_transformation == "edge" || rule.type_transformation == "edge2"
								if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
									exit = execution.backtracking_shape(chosen_rule_id, cont)
								else
									execution.num_steps.push(1)
									execution.apply_r_shape(chosen_rule_id, cont, current, false)
									execution.apply_r = true
								end
								if !exit
									UI.messagebox("No se pueden satisfacer las restricciones")
								else
									execution.apply_r = true
								end
							else
								UI.messagebox("Tiene seleccionado el botn de crecimiento vertical y la regla que ha seleccionado slo crece en el plano horizontal")
							end
						elsif shape.type.include? "hexagonal"
							if rule.type_transformation == "face" || rule.type_transformation == "edge"
								if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
									exit = execution.backtracking_shape(chosen_rule_id, cont)
								else
									execution.num_steps.push(1)
									execution.apply_r_shape(chosen_rule_id, cont, current, false)
									execution.apply_r = true
								end
								if !exit
									UI.messagebox("No se pueden satisfacer las restricciones")
								else
									execution.apply_r = true
								end
							else
								UI.messagebox("Tiene seleccionado el botn de crecimiento vertical y la regla que ha seleccionado slo crece en el plano horizontal")
							end
						else
							if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
								exit = execution.backtracking_shape(chosen_rule_id, cont)
							else
								execution.num_steps.push(1)
								execution.apply_r_shape(chosen_rule_id, cont, current, false)
								execution.apply_r = true
							end
							if !exit
								UI.messagebox("No se pueden satisfacer las restricciones")
							else
								execution.apply_r = true
							end
						end
					elsif execution.left
						rule = execution.grammar.search_rule_by_id(chosen_rule_id)
						if shape.type.include? "triangle"
							if rule.type_transformation == "edge3" || rule.type_transformation == "face2" || rule.type_transformation == "edge" 
								if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
									exit = execution.backtracking_shape(chosen_rule_id, cont)
								else
									execution.num_steps.push(1)
									execution.apply_r_shape(chosen_rule_id, cont, current, false)
									execution.apply_r = true
								end
								if !exit
									UI.messagebox("No se pueden satisfacer las restricciones")
								else
									execution.apply_r = true
								end
							else
								UI.messagebox("Tiene seleccionado el botn de crecimiento horizontal y la regla que ha seleccionado slo crece en el plano vertical")
							end
						elsif shape.type.include? "hexagonal"
							if rule.type_transformation == "face2"
								if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
									exit = execution.backtracking_shape(chosen_rule_id, cont)
								else
									execution.num_steps.push(1)
									execution.apply_r_shape(chosen_rule_id, cont, current, false)
									execution.apply_r = true
								end
								if !exit
									UI.messagebox("No se pueden satisfacer las restricciones")
								else
									execution.apply_r = true
								end
							else
								UI.messagebox("Tiene seleccionado el botn de crecimiento horizontal y la regla que ha seleccionado slo crece en el plano vertical")
							end
						elsif shape.type.include? "cube"
							if rule.type_transformation == "face" || rule.type_transformation == "edge"
								if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
									exit = execution.backtracking_shape(chosen_rule_id, cont)
								else
									execution.num_steps.push(1)
									execution.apply_r_shape(chosen_rule_id, cont, current, false)
									execution.apply_r = true
								end
								if !exit
									UI.messagebox("No se pueden satisfacer las restricciones")
								else
									execution.apply_r = true
								end
							else
								UI.messagebox("Tiene seleccionado el botn de crecimiento horizontal y la regla que ha seleccionado slo crece en el plano vertical")
							end
						else
							if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
								exit = execution.backtracking_shape(chosen_rule_id, cont)
							else
								execution.num_steps.push(1)
								execution.apply_r_shape(chosen_rule_id, cont, current, false)
								execution.apply_r = true
							end
							if !exit
								UI.messagebox("No se pueden satisfacer las restricciones")
							else
								execution.apply_r = true
							end
						end
					else
						if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
							exit = execution.backtracking_shape(chosen_rule_id, cont)
						else
							execution.num_steps.push(1)
							execution.apply_r_shape(chosen_rule_id, cont, current, false)
							execution.apply_r = true
						end
						if !exit
							UI.messagebox("No se pueden satisfacer las restricciones")
						else
							execution.apply_r = true
						end
					end
				end
			else
				UI.messagebox("Debe seleccionar una figura de su megaestructura")
			end
		else
			prompts = ["Elija el id de una regla: "]
			default = [1]
			rule_list = PracticaUtils.create_rule_list()
			list = [rule_list]
			exit = true
			input = UI.inputbox prompts, default, list, "Ejecutar una regla"
			if input
				shape = PracticaUtils.current_shape
				chosen_rule_idx = input[0]
				chosen_rule_id = execution.grammar.rules[chosen_rule_idx.to_i - 1].rule_id
				if execution.up && execution.left
					if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
						exit = execution.backtracking(chosen_rule_id)
					else
						execution.num_steps.push(1)
						execution.apply_r(chosen_rule_id, shape, false)
						execution.apply_r = true
					end
					if !exit
						UI.messagebox("No se pueden satisfacer las restricciones")
					else
						execution.apply_r = true
					end
				elsif execution.up
					rule = execution.grammar.search_rule_by_id(chosen_rule_id)
					if shape.type.include? "triangle"
						if rule.type_transformation == "face" || rule.type_transformation == "point" || rule.type_transformation == "point2" || rule.type_transformation == "edge" || rule.type_transformation == "edge2"
							if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
								exit = execution.backtracking(chosen_rule_id)
							else
								execution.num_steps.push(1)
								execution.apply_r(chosen_rule_id, shape, false)
								execution.apply_r = true
							end
							if !exit
								UI.messagebox("No se pueden satisfacer las restricciones")
							else
								execution.apply_r = true
							end
						else
							UI.messagebox("Tiene seleccionado el botn de crecimiento vertical y la regla que ha seleccionado slo crece en el plano horizontal")
						end
					elsif shape.type.include? "hexagonal"
						if rule.type_transformation == "face" || rule.type_transformation == "edge"
							if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
								exit = execution.backtracking(chosen_rule_id)
							else
								execution.num_steps.push(1)
								execution.apply_r(chosen_rule_id, shape, false)
								execution.apply_r = true
							end
							if !exit
								UI.messagebox("No se pueden satisfacer las restricciones")
							else
								execution.apply_r = true
							end
						else
							UI.messagebox("Tiene seleccionado el botn de crecimiento vertical y la regla que ha seleccionado slo crece en el plano horizontal")
						end
					else
						if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
							exit = execution.backtracking(chosen_rule_id)
						else
							execution.num_steps.push(1)
							execution.apply_r(chosen_rule_id, shape, false)
							execution.apply_r = true
						end
						if !exit
							UI.messagebox("No se pueden satisfacer las restricciones")
						else
							execution.apply_r = true
						end
					end
				elsif execution.left
					rule = execution.grammar.search_rule_by_id(chosen_rule_id)
					if shape.type.include? "triangle"
						if rule.type_transformation == "edge3" || rule.type_transformation == "face2" || rule.type_transformation == "edge" 
							if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
								exit = execution.backtracking(chosen_rule_id)
							else
								execution.num_steps.push(1)
								execution.apply_r(chosen_rule_id, shape, false)
								execution.apply_r = true
							end
							if !exit
								UI.messagebox("No se pueden satisfacer las restricciones")
							else
								execution.apply_r = true
							end
						else
							UI.messagebox("Tiene seleccionado el botn de crecimiento vertical y la regla que ha seleccionado slo crece en el plano horizontal")
						end
					elsif shape.type.include? "hexagonal"
						if rule.type_transformation == "face2"
							if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
								exit = execution.backtracking(chosen_rule_id)
							else
								execution.num_steps.push(1)
								execution.apply_r(chosen_rule_id, shape, false)
								execution.apply_r = true
							end
							if !exit
								UI.messagebox("No se pueden satisfacer las restricciones")
							else
								execution.apply_r = true
							end
						else
							UI.messagebox("Tiene seleccionado el botn de crecimiento vertical y la regla que ha seleccionado slo crece en el plano horizontal")
						end
					elsif shape.type.include? "cube"
						if rule.type_transformation == "face" || rule.type_transformation == "edge"
							if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
								exit = execution.backtracking(chosen_rule_id)
							else
								execution.num_steps.push(1)
								execution.apply_r(chosen_rule_id, shape, false)
								execution.apply_r = true
							end
							if !exit
								UI.messagebox("No se pueden satisfacer las restricciones")
							else
								execution.apply_r = true
							end
						else
							UI.messagebox("Tiene seleccionado el botn de crecimiento vertical y la regla que ha seleccionado slo crece en el plano horizontal")
						end
					else
						if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
							exit = execution.backtracking(chosen_rule_id)
						else
							execution.num_steps.push(1)
							execution.apply_r(chosen_rule_id, shape, false)
							execution.apply_r = true
						end
						if !exit
							UI.messagebox("No se pueden satisfacer las restricciones")
						else
							execution.apply_r = true
						end
					end
				else
					if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
						exit = execution.backtracking(chosen_rule_id)
					else
						execution.num_steps.push(1)
						execution.apply_r(chosen_rule_id, shape, false)
						execution.apply_r = true
					end
					if !exit
						UI.messagebox("No se pueden satisfacer las restricciones")
					else
						execution.apply_r = true
					end
				end
			end
		end
		string = ""
		current = PracticaUtils.current_shape
		if execution.num_shapes || execution.up || execution.left
			string = "Restricciones activas: "
		end
		if  execution.num_shapes && execution.up && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal, crecimiento vertical" 
		elsif execution.num_shapes && execution.up
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento vertical" 
		elsif execution.num_shapes && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal" 
		elsif execution.num_shapes
			string += "nmero de piezas (#{execution.max_num_shapes})" 
		elsif execution.up && execution.left
			string += "crecimiento horizontal, crecimiento vertical" 
		elsif execution.up
			string += "crecimiento vertical" 
		elsif execution.left
			string += "crecimiento horizontal" 
		end
		execution.text.text = "Nmero de piezas = #{current.c.length}\n" + string
	}
	exe_cmd.tooltip = "Ejecutar una regla"
	exe_cmd.small_icon = File.join(Constants::ICONS_DIR, "execute.PNG")
	exe_cmd.large_icon = File.join(Constants::ICONS_DIR, "execute.PNG")
	toolbar.add_item exe_cmd
	
	# Ramdom Execute command
	rand_exe_cmd = UI::Command.new("apply_random_rule"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active
		
		grammar_aux = execution.grammar.duplicate
		
		prompts = ["Numero de reglas aleatorias a aplicar: "]
		defaults = [""]
		input = UI.inputbox prompts, defaults, "Ejecutar n veces una regla aleatoria"
		if input
			shape = PracticaUtils.current_shape
			selection = Sketchup.active_model.selection.to_a
			shapes = Array.new
			aux = Array.new
			if !selection.empty?
				
				
				 # Look at all of the entities in the selection.
				face_count= 0
				current = PracticaUtils.current_shape
				current.c.sort! { |shape1, shape2|
					shape1.position <=> shape2.position
				}
				cont = 0
				max = shape.c.length
				while (cont < max)
					if current.type.include? "cube"
						if selection.include? current.c[cont].cube.group
							aux.push current.c[cont]
						end
						cont+=1
					else
						if selection.include? current.c[cont].prism.group
							aux.push current.c[cont]
						end
						cont+=1
					end
				end
				shape1 = shape.duplicate
				shape1.c = aux
			end
			cont = 0
			max = input[0].to_i
			if execution.up && !execution.left
				array_aux = Array.new
				for i in 0..grammar_aux.rules.length-1
					chosen_rule_id = grammar_aux.rules[i].rule_id
					rule = execution.grammar.search_rule_by_id(chosen_rule_id)
					if shape.type.include? "cube"
						if rule.type_transformation == "face" || rule.type_transformation == "edge" || rule.type_transformation == "point"
							array_aux.push(chosen_rule_id)
						end
					elsif shape.type.include? "triangle"
						if rule.type_transformation == "face" || rule.type_transformation == "point" || rule.type_transformation == "point2" || rule.type_transformation == "edge2"
							array_aux.push(chosen_rule_id)
						end
					elsif shape.type.include? "hexagonal"
						if rule.type_transformation == "face" || rule.type_transformation == "edge"
							array_aux.push(chosen_rule_id)
						end
					end
				end
				if array_aux.empty?
					UI.messagebox("Tiene el botn de expansin vertical activado y todas las reglas se expanden horizontalmente")
				else
					while ((cont < max)&&(!array_aux.empty?))
						chosen_rule_idx = rand(array_aux.length)
						chosen_rule_id = array_aux[chosen_rule_idx]
						if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
							if aux.empty?
								exit = execution.backtracking(chosen_rule_id, true)
								if exit
									execution.apply_r = true
								end
							else
								exit = execution.backtracking_sel(chosen_rule_id, shape1, true)
								if exit
									execution.apply_r = true
								end
							end
							while(!exit&&(!array_aux.empty?))
								array_aux.delete(chosen_rule_id)
								if !array_aux.empty?
									chosen_rule_idx = rand(array_aux.length)
									chosen_rule_id = array_aux[chosen_rule_idx]
									if aux.empty?
										exit = execution.backtracking(chosen_rule_id, true)
										if exit
											execution.apply_r = true
										end
									else
										exit = execution.backtracking_sel(chosen_rule_id, shape1, true)
										if exit
											execution.apply_r = true
										end
									end
								end
							end
						else
							#Lo de la seleccin no lo voy a poner aqu porque siempre tenemos una restriccin activada area
							execution.apply_r(chosen_rule_id, shape, false)
						end
						cont+=1
					end
					if array_aux.empty?
						UI.messagebox("No se pueden satisfacer las restricciones")
						execution.num_steps.push(cont-1)
					else
						execution.num_steps.push(cont)
					end
				end
			elsif execution.left && !execution.up
				array_aux = Array.new
				for i in 0..grammar_aux.rules.length-1
					chosen_rule_id = grammar_aux.rules[i].rule_id
					rule = execution.grammar.search_rule_by_id(chosen_rule_id)
					if shape.type.include? "cube"
						if rule.type_transformation == "face" || rule.type_transformation == "edge"
							array_aux.push(chosen_rule_id)
						end
					elsif shape.type.include? "triangle"
						if rule.type_transformation == "edge3" || rule.type_transformation == "face2" || rule.type_transformation == "edge" 
							array_aux.push(chosen_rule_id)
						end
					elsif shape.type.include? "hexagonal"
						if rule.type_transformation == "face2"
							array_aux.push(chosen_rule_id)
						end
					end
				end
				if array_aux.empty?
					UI.messagebox("Tiene el botn de expansin horizontal activado y todas las reglas se expanden verticalmente")
				else
					while ((cont < max)&&(!array_aux.empty?))
						chosen_rule_idx = rand(array_aux.length)
						chosen_rule_id = array_aux[chosen_rule_idx]
						if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
							if aux.empty?
								exit = execution.backtracking(chosen_rule_id, true)
								if exit
									execution.apply_r = true
								end
							else
								exit = execution.backtracking_sel(chosen_rule_id, shape1, true)
								if exit
									execution.apply_r = true
								end
							end
							while(!exit&&(!array_aux.empty?))
								array_aux.delete(chosen_rule_id)
								if !array_aux.empty?
									chosen_rule_idx = rand(array_aux.length)
									chosen_rule_id = array_aux[chosen_rule_idx]
									if aux.empty?
										exit = execution.backtracking(chosen_rule_id, true)
										if exit
											execution.apply_r = true
										end
									else
										exit = execution.backtracking_sel(chosen_rule_id, shape1, true)
										if exit
											execution.apply_r = true
										end
									end
								end
							end
						else
							execution.apply_r(chosen_rule_id, shape, false)
						end
						cont+=1
					end
					if array_aux.empty?
						UI.messagebox("No se pueden satisfacer las restricciones")
						execution.num_steps.push(cont-1)
						
					else
						execution.num_steps.push(cont)
					end
				end
			else
				while ((cont < max)&&(!grammar_aux.rules.empty?))
					chosen_rule_idx = rand(grammar_aux.rules.length)
					chosen_rule_id = grammar_aux.rules[chosen_rule_idx].rule_id
					if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
						if aux.empty?
							exit = execution.backtracking(chosen_rule_id, true)
							if exit
								execution.apply_r = true
							end
						else
							exit = execution.backtracking_sel(chosen_rule_id, shape1, true)
							if exit
								execution.apply_r = true
							end
						end
						while(!exit&&(!grammar_aux.rules.empty?))
							grammar_aux.remove_rule(chosen_rule_idx)
							if !grammar_aux.rules.empty?
								chosen_rule_idx = rand(grammar_aux.rules.length)
								chosen_rule_id = grammar_aux.rules[chosen_rule_idx].rule_id
								if aux.empty?
									exit = execution.backtracking(chosen_rule_id, true)
									if exit
										execution.apply_r = true
									end
								else
									exit = execution.backtracking_sel(chosen_rule_id, shape1, true)
									if exit
										execution.apply_r = true
									end
								end
							end
						end
					else
						execution.apply_r(chosen_rule_id, shape, false)
						execution.apply_r = true
					end
					cont+=1
				end
				if grammar_aux.rules.empty?
					UI.messagebox("No se pueden satisfacer las restricciones")
					execution.num_steps.push(cont-1)
				else
					execution.num_steps.push(cont)
				end
			end
		end
		string = ""
		current = PracticaUtils.current_shape
		if execution.num_shapes || execution.up || execution.left
			string = "Restricciones activas: "
		end
		if  execution.num_shapes && execution.up && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal, crecimiento vertical" 
		elsif execution.num_shapes && execution.up
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento vertical" 
		elsif execution.num_shapes && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal" 
		elsif execution.num_shapes
			string += "nmero de piezas (#{execution.max_num_shapes})" 
		elsif execution.up && execution.left
			string += "crecimiento horizontal, crecimiento vertical" 
		elsif execution.up
			string += "crecimiento vertical" 
		elsif execution.left
			string += "crecimiento horizontal" 
		end
		execution.text.text = "Nmero de piezas = #{current.c.length}\n" + string
	}
	rand_exe_cmd.tooltip = "Ejecutar reglas aleatorias"
	rand_exe_cmd.small_icon = File.join(Constants::ICONS_DIR, "execute_random.PNG")
	rand_exe_cmd.large_icon = File.join(Constants::ICONS_DIR, "execute_random.PNG")
	toolbar.add_item rand_exe_cmd
	
	# Execute command n times
	rand_exe_cmd = UI::Command.new("apply_n_rule"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active
		
		prompts = ["Elija el id de una regla", "Numero de veces que desea aplicar la regla"]
		default = [1, ""]
		rule_list = PracticaUtils.create_rule_list()
		list = [rule_list]
		input = UI.inputbox prompts, default, list, "Ejecutar una regla n veces"
		if input
			shape = PracticaUtils.current_shape
			selection = Sketchup.active_model.selection.to_a
			shapes = Array.new
			aux = Array.new
			if !selection.empty?
				
				
				 # Look at all of the entities in the selection.
				face_count= 0
				current = PracticaUtils.current_shape
				current.c.sort! { |shape1, shape2|
					shape1.position <=> shape2.position
				}
				cont = 0
				max = shape.c.length
				while (cont < max)
					if current.type.include? "cube"
						if selection.include? current.c[cont].cube.group
							aux.push current.c[cont]
						end
						cont+=1
					else
						if selection.include? current.c[cont].prism.group
							aux.push current.c[cont]
						end
						cont+=1
					end
				end
				shape1 = current.duplicate
				shape1.c = aux
			end
			cont = 0
			max = input[1].to_i
			exit = true
			chosen_rule_idx = input[0]
			chosen_rule_id = execution.grammar.rules[chosen_rule_idx.to_i - 1].rule_id
			rule = execution.grammar.search_rule_by_id(chosen_rule_id)
			if execution.up && execution.left
				while ((cont < max)&&(exit))
					if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
						if aux.empty?
							exit = execution.backtracking(chosen_rule_id, true)
						else
							exit = execution.backtracking_sel(chosen_rule_id, shape1, true)
						end
					else
						execution.apply_r(chosen_rule_id, shape, false)
						execution.apply_r = true
					end
					cont+=1
				end
				if !exit
					UI.messagebox("No se pueden satisfacer las restricciones")
					execution.num_steps.push(cont-1)
					if cont-1 != 0
						execution.apply_r = true
					end
				else
					execution.num_steps.push(cont)
					execution.apply_r = true
				end	
			elsif execution.up
				rule = execution.grammar.search_rule_by_id(chosen_rule_id)
				if shape.type.include? "triangle"
					if rule.type_transformation == "face" || rule.type_transformation == "point" || rule.type_transformation == "point2" || rule.type_transformation == "edge2"
						while ((cont < max)&&(exit))
							if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
								if aux.empty?
									exit = execution.backtracking(chosen_rule_id, true)
								else
									exit = execution.backtracking_sel(chosen_rule_id, shape1, true)
								end
							else
								execution.apply_r(chosen_rule_id, shape, false)
								execution.apply_r = true
							end
							cont+=1
						end
						if !exit
							UI.messagebox("No se pueden satisfacer las restricciones")
							execution.num_steps.push(cont-1)
							if cont-1 != 0
								execution.apply_r = true
							end
						else
							execution.num_steps.push(cont)
							execution.apply_r = true
						end
					else
						UI.messagebox("Tiene seleccionado el botn de crecimiento vertical y la regla que ha seleccionado slo crece en el plano horizontal")
					end
				elsif shape.type.include? "hexagonal"
					if rule.type_transformation == "face" || rule.type_transformation == "edge"
						while ((cont < max)&&(exit))
							if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
								if aux.empty?
									exit = execution.backtracking(chosen_rule_id, true)
								else
									exit = execution.backtracking_sel(chosen_rule_id, shape1, true)
								end
							else
								execution.apply_r(chosen_rule_id, shape, false)
								execution.apply_r = true
							end
							cont+=1
						end
						if !exit
							UI.messagebox("No se pueden satisfacer las restricciones")
							execution.num_steps.push(cont-1)
							if cont-1 != 0
								execution.apply_r = true
							end
						else
							execution.num_steps.push(cont)
							execution.apply_r = true
						end
					else
						UI.messagebox("Tiene seleccionado el botn de crecimiento vertical y la regla que ha seleccionado slo crece en el plano horizontal")
					end
				else
					while ((cont < max)&&(exit))
						if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
							if aux.empty?
								exit = execution.backtracking(chosen_rule_id, true)
							else
								exit = execution.backtracking_sel(chosen_rule_id, shape1, true)
							end
						else
							execution.apply_r(chosen_rule_id, shape, false)
							execution.apply_r = true
						end
						cont+=1
					end
					if !exit
						UI.messagebox("No se pueden satisfacer las restricciones")
						execution.num_steps.push(cont-1)
						if cont-1 != 0
							execution.apply_r = true
						end
					else
						execution.num_steps.push(cont)
						execution.apply_r = true
					end
				end
			elsif execution.left
				rule = execution.grammar.search_rule_by_id(chosen_rule_id)
				if shape.type.include? "triangle"
					if rule.type_transformation == "edge3" || rule.type_transformation == "face2" || rule.type_transformation == "edge" 
						while ((cont < max)&&(exit))
							if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
								if aux.empty?
									exit = execution.backtracking(chosen_rule_id, true)
								else
									exit = execution.backtracking_sel(chosen_rule_id, shape1, true)
								end
							else
								execution.apply_r(chosen_rule_id, shape, false)
								execution.apply_r = true
							end
							cont+=1
						end
						if !exit
							UI.messagebox("No se pueden satisfacer las restricciones")
							execution.num_steps.push(cont-1)
							if cont-1 != 0
								execution.apply_r = true
							end
						else
							execution.num_steps.push(cont)
							execution.apply_r = true
						end
					else
						UI.messagebox("Tiene seleccionado el botn de crecimiento vertical y la regla que ha seleccionado slo crece en el plano horizontal")
					end
				elsif shape.type.include? "hexagonal"
					if rule.type_transformation == "face2"
						while ((cont < max)&&(exit))
							if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
								if aux.empty?
									exit = execution.backtracking(chosen_rule_id, true)
								else
									exit = execution.backtracking_sel(chosen_rule_id, shape1, true)
								end
							else
								execution.apply_r(chosen_rule_id, shape, false)
								execution.apply_r = true
							end
							cont+=1
						end
						if !exit
							UI.messagebox("No se pueden satisfacer las restricciones")
							execution.num_steps.push(cont-1)
							if cont-1 != 0
								execution.apply_r = true
							end
						else
							execution.num_steps.push(cont)
							execution.apply_r = true
						end
					else
						UI.messagebox("Tiene seleccionado el botn de crecimiento vertical y la regla que ha seleccionado slo crece en el plano horizontal")
					end
				elsif shape.type.include? "cube"
					if rule.type_transformation == "face" || rule.type_transformation == "edge"
						while ((cont < max)&&(exit))
							if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
								if aux.empty?
									exit = execution.backtracking(chosen_rule_id, true)
								else
									exit = execution.backtracking_sel(chosen_rule_id, shape1, true)
								end
							else
								execution.apply_r(chosen_rule_id, shape, false)
								execution.apply_r = true
							end
							cont+=1
						end
						if !exit
							UI.messagebox("No se pueden satisfacer las restricciones")
							execution.num_steps.push(cont-1)
							if cont-1 != 0
								execution.apply_r = true
							end
						else
							execution.num_steps.push(cont)
							execution.apply_r = true
						end
					else
						UI.messagebox("Tiene seleccionado el botn de crecimiento vertical y la regla que ha seleccionado slo crece en el plano horizontal")
					end
				else
					while ((cont < max)&&(exit))
						if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
							if aux.empty?
								exit = execution.backtracking(chosen_rule_id, true)
							else
								exit = execution.backtracking_sel(chosen_rule_id, shape1, true)
							end
						else
							execution.apply_r(chosen_rule_id, shape, false)
							execution.apply_r = true
						end
						cont+=1
					end
					if !exit
						UI.messagebox("No se pueden satisfacer las restricciones")
						execution.num_steps.push(cont-1)
						if cont-1 != 0
							execution.apply_r = true
						end
					else
						execution.num_steps.push(cont)
						execution.apply_r = true
					end
				end
			else
				while ((cont < max)&&(exit))
					if execution.area || execution.hill.painted || execution.num_shapes || execution.volumen
						if aux.empty?
							exit = execution.backtracking(chosen_rule_id, true)
						else
							exit = execution.backtracking_sel(chosen_rule_id, shape1, true)
						end
					else
						execution.apply_r(chosen_rule_id, shape, false)
						execution.apply_r = true
					end
					cont+=1
				end
				if !exit
					UI.messagebox("No se pueden satisfacer las restricciones")
					execution.num_steps.push(cont-1)
					if cont-1 != 0
						execution.apply_r = true
					end
				else
					execution.num_steps.push(cont)
					execution.apply_r = true
				end
			end
			
		end
		string = ""
		current = PracticaUtils.current_shape
		if execution.num_shapes || execution.up || execution.left
			string = "Restricciones activas: "
		end
		if  execution.num_shapes && execution.up && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal, crecimiento vertical" 
		elsif execution.num_shapes && execution.up
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento vertical" 
		elsif execution.num_shapes && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal" 
		elsif execution.num_shapes
			string += "nmero de piezas (#{execution.max_num_shapes})" 
		elsif execution.up && execution.left
			string += "crecimiento horizontal, crecimiento vertical" 
		elsif execution.up
			string += "crecimiento vertical" 
		elsif execution.left
			string += "crecimiento horizontal" 
		end
		execution.text.text = "Nmero de piezas = #{current.c.length}\n" + string
	}
	rand_exe_cmd.tooltip = "Ejecutar una regla n veces"
	rand_exe_cmd.small_icon = File.join(Constants::ICONS_DIR, "execute_n.PNG")
	rand_exe_cmd.large_icon = File.join(Constants::ICONS_DIR, "execute_n.PNG")
	toolbar.add_item rand_exe_cmd
	
	
	# Undo step command
	undo_step_cmd = UI::Command.new("undo_step"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active
		
		execution.undo
		string = ""
		current = PracticaUtils.current_shape
		if execution.num_shapes || execution.up || execution.left
			string = "Restricciones activas: "
		end
		if  execution.num_shapes && execution.up && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal, crecimiento vertical" 
		elsif execution.num_shapes && execution.up
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento vertical" 
		elsif execution.num_shapes && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal" 
		elsif execution.num_shapes
			string += "nmero de piezas (#{execution.max_num_shapes})" 
		elsif execution.up && execution.left
			string += "crecimiento horizontal, crecimiento vertical" 
		elsif execution.up
			string += "crecimiento vertical" 
		elsif execution.left
			string += "crecimiento horizontal" 
		end
		execution.text.text = "Nmero de piezas = #{current.c.length}\n" + string
	}
	undo_step_cmd.tooltip = "Deshacer paso"
	undo_step_cmd.small_icon = File.join(Constants::ICONS_DIR, "undo.PNG")
	undo_step_cmd.large_icon = File.join(Constants::ICONS_DIR, "undo.PNG")
	toolbar.add_item undo_step_cmd
	
	# Undo n step command
	undo_n_step_cmd = UI::Command.new("undo_n_step"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active
		execution.undo_n
		string = ""
		current = PracticaUtils.current_shape
		if execution.num_shapes || execution.up || execution.left
			string = "Restricciones activas: "
		end
		if  execution.num_shapes && execution.up && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal, crecimiento vertical" 
		elsif execution.num_shapes && execution.up
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento vertical" 
		elsif execution.num_shapes && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal" 
		elsif execution.num_shapes
			string += "nmero de piezas (#{execution.max_num_shapes})" 
		elsif execution.up && execution.left
			string += "crecimiento horizontal, crecimiento vertical" 
		elsif execution.up
			string += "crecimiento vertical" 
		elsif execution.left
			string += "crecimiento horizontal" 
		end
		execution.text.text = "Nmero de piezas = #{current.c.length}\n" + string
	}
	undo_n_step_cmd.tooltip = "Deshacer el ultimo comando"
	undo_n_step_cmd.small_icon = File.join(Constants::ICONS_DIR, "undo_n.PNG")
	undo_n_step_cmd.large_icon = File.join(Constants::ICONS_DIR, "undo_n.PNG")
	toolbar.add_item undo_n_step_cmd
	
	# Reset command
	reset_cmd = UI::Command.new("reset"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active
		
		execution.reset
		string = ""
		current = PracticaUtils.current_shape
		if execution.num_shapes || execution.up || execution.left
			string = "Restricciones activas: "
		end
		if  execution.num_shapes && execution.up && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal, crecimiento vertical" 
		elsif execution.num_shapes && execution.up
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento vertical" 
		elsif execution.num_shapes && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal" 
		elsif execution.num_shapes
			string += "nmero de piezas (#{execution.max_num_shapes})" 
		elsif execution.up && execution.left
			string += "crecimiento horizontal, crecimiento vertical" 
		elsif execution.up
			string += "crecimiento vertical" 
		elsif execution.left
			string += "crecimiento horizontal" 
		end
		execution.text.text = "Nmero de piezas = #{current.c.length}\n" + string
	}
	reset_cmd.tooltip = "Resetear"
	reset_cmd.small_icon = File.join(Constants::ICONS_DIR, "reset.PNG")
	reset_cmd.large_icon = File.join(Constants::ICONS_DIR, "reset.PNG")
	toolbar.add_item reset_cmd
	
	# Delete shapes
	delete_cmd = UI::Command.new("delete"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active
		
		selection = Sketchup.active_model.selection.to_a
		if !selection.empty?
			
			 # Look at all of the entities in the selection.
			face_count= 0
			current = PracticaUtils.current_shape
			current.c.sort! { |shape1, shape2|
				shape1.position <=> shape2.position
			}
			cont = 0
			max = current.c.length
			shapes = Array.new
			while (cont < max)
				if current.type.include? "cube"
					if selection.include? current.c[cont].cube.group
						if current.c[cont] == execution.axiom
							shapes.push(cont)
							UI.messagebox("No se puede borrar el axioma")
							cont+=1
						else
							shapes.push(cont)
							execution.delete_shape_history (current.c[cont].position)
							current.c[cont].cube.erase
							current.c.delete_at(cont)
						end
					else
						cont+=1
					end
				else
					if selection.include? current.c[cont].prism.group
						if current.c[cont] == execution.axiom
							UI.messagebox("No se puede borrar el axioma")
							cont+=1
						else
							shapes.push(cont)
							if current.type.include? "triangle"
								execution.delete_shape_history (current.c[cont].position, current.c[cont].turned)
							else
								execution.delete_shape_history (current.c[cont].position)
							end
							current.c[cont].prism.erase
							current.c.delete_at(cont)
						end
					else
						cont+=1
					end
				end
				max = current.c.length
			end
		else
			UI.messagebox("No hay ninguna figura seleccionada. Por favor, seleccione alguna figura de la megaestructura")
		end
		
		string = ""
		current = PracticaUtils.current_shape
		if execution.num_shapes || execution.up || execution.left
			string = "Restricciones activas: "
		end
		if  execution.num_shapes && execution.up && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal, crecimiento vertical" 
		elsif execution.num_shapes && execution.up
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento vertical" 
		elsif execution.num_shapes && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal" 
		elsif execution.num_shapes
			string += "nmero de piezas (#{execution.max_num_shapes})" 
		elsif execution.up && execution.left
			string += "crecimiento horizontal, crecimiento vertical" 
		elsif execution.up
			string += "crecimiento vertical" 
		elsif execution.left
			string += "crecimiento horizontal" 
		end
		execution.text.text = "Nmero de piezas = #{current.c.length}\n" + string
	}
	delete_cmd.tooltip = "Borrar figuras"
	delete_cmd.small_icon = File.join(Constants::ICONS_DIR, "delete_shape.PNG")
	delete_cmd.large_icon = File.join(Constants::ICONS_DIR, "delete_shape.PNG")
	toolbar.add_item delete_cmd
	
	toolbar.add_separator
	
	# Change shape
	change_shape = UI::Command.new("change_shape"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active
			
		max_rules = execution.grammar.rules.length
		cont = 0
		while cont < max_rules
			execution.grammar.rules[cont].erase
			cont+=1
		end
		PracticaUtils.current_shape.erase
		if execution.hill.painted
			PracticaUtils.hills.erase
		end
		if execution.pyramid.painted
			execution.pyramid.erase
		end
		Sketchup.active_model.entities.erase_entities execution.text
		#Create the prompt
		create_options()
	}
	change_shape.tooltip = "Cambiar figura"
	change_shape.small_icon = File.join(Constants::ICONS_DIR, "change_shape1.PNG")
	change_shape.large_icon = File.join(Constants::ICONS_DIR, "change_shape1.PNG")
	toolbar.add_item change_shape
	
	# Show the pyramid
	show_pyramid = UI::Command.new("show_pyramid"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active
			
		if execution.pyramid.painted
			execution.pyramid.erase
		else
			execution.pyramid.paint
		end
		if execution.volumen
			execution.volumen = false
		else
			execution.volumen = true
		end
	}
	show_pyramid.tooltip = "Activa la restriccion de volumen"
	show_pyramid.small_icon = File.join(Constants::ICONS_DIR, "pyramid.PNG")
	show_pyramid.large_icon = File.join(Constants::ICONS_DIR, "pyramid.PNG")
	toolbar.add_item show_pyramid
	
	# Active the constraint
	teste_shapes = UI::Command.new("teste_shapes"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active
			
		if execution.num_shapes
			execution.num_shapes = false
			UI.messagebox("Restriccin de nmero de piezas desactivada")
		else
			execution.num_shapes = true
			UI.messagebox("Restriccin de nmero de piezas activada")
		end
		string = ""
		current = PracticaUtils.current_shape
		if execution.num_shapes || execution.up || execution.left
			string = "Restricciones activas: "
		end
		if  execution.num_shapes && execution.up && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal, crecimiento vertical" 
		elsif execution.num_shapes && execution.up
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento vertical" 
		elsif execution.num_shapes && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal" 
		elsif execution.num_shapes
			string += "nmero de piezas (#{execution.max_num_shapes})" 
		elsif execution.up && execution.left
			string += "crecimiento horizontal, crecimiento vertical" 
		elsif execution.up
			string += "crecimiento vertical" 
		elsif execution.left
			string += "crecimiento horizontal" 
		end
		execution.text.text = "Nmero de piezas = #{current.c.length}\n" + string
	}
	teste_shapes.tooltip = "Limita el numero de piezas"
	teste_shapes.small_icon = File.join(Constants::ICONS_DIR, "max_piezas.PNG")
	teste_shapes.large_icon = File.join(Constants::ICONS_DIR, "max_piezas.PNG")
	toolbar.add_item teste_shapes
	
	conf_shapes = UI::Command.new("conf_shapes"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active
		
		current = PracticaUtils.current_shape
		prompts = ["Numero mximo de piezas: "]
		defaults = [""]
		input = UI.inputbox prompts, defaults, "Configuracion del numero maximo de piezas"
		if input
			max = input[0]
			if /^[\d]+(\.[\d]+){0,1}$/ === max
				if max.to_i < current.c.length
					UI.messagebox("El nmero de piezas mximo debe ser mayor que el nmero de piezas actuales")
				else
					execution.max_num_shapes = max.to_i
				end
			else
				UI.messagebox("Debe introducir un nmero")
			end
		end
		string = ""
		if execution.num_shapes || execution.up || execution.left
			string = "Restricciones activas: "
		end
		if  execution.num_shapes && execution.up && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal, crecimiento vertical" 
		elsif execution.num_shapes && execution.up
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento vertical" 
		elsif execution.num_shapes && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal" 
		elsif execution.num_shapes
			string += "nmero de piezas (#{execution.max_num_shapes})" 
		elsif execution.up && execution.left
			string += "crecimiento horizontal, crecimiento vertical" 
		elsif execution.up
			string += "crecimiento vertical" 
		elsif execution.left
			string += "crecimiento horizontal" 
		end
		execution.text.text = "Nmero de piezas = #{current.c.length}\n" + string
		
	}
	conf_shapes.tooltip = "Configuracion del numero maximo de piezas"
	conf_shapes.small_icon = File.join(Constants::ICONS_DIR, "conf_max_piezas.PNG")
	conf_shapes.large_icon = File.join(Constants::ICONS_DIR, "conf_max_piezas.PNG")
	toolbar.add_item conf_shapes
	
	# Activate the curves
	activate_curves = UI::Command.new("activate_curves"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active
			


		chosen_path = UI.openpanel("Abrir mapa de curvas de nivel", "" ,"*.txt")
		if chosen_path	
			if PracticaUtils.get_extension(chosen_path) == "txt"
				exit = execution.hill.load(chosen_path)
				if !exit
					execution.hill.paint
				end
			end
		end	
	}
	activate_curves.tooltip = "Aadir mapa de curvas de nivel"
	activate_curves.small_icon = File.join(Constants::ICONS_DIR, "curves.PNG")
	activate_curves.large_icon = File.join(Constants::ICONS_DIR, "curves.PNG")
	toolbar.add_item activate_curves
	
	# Delete the curves
	delete_curves = UI::Command.new("delete_curves"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active
			
		if execution.hill.painted
			execution.hill.erase
		else
			UI.messagebox("No hay colinas")
		end
	}
	delete_curves.tooltip = "Borrar mapa de curvas de nivel"
	delete_curves.small_icon = File.join(Constants::ICONS_DIR, "remove_curves.PNG")
	delete_curves.large_icon = File.join(Constants::ICONS_DIR, "remove_curves.PNG")
	toolbar.add_item delete_curves
	
	toolbar.add_separator
	
	# Active the constraint
	grow_up = UI::Command.new("grow_up"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active
			
		if execution.up
			execution.up = false
			UI.messagebox("Restriccin de crecimiento vertical desactivada")
		else
			execution.up = true
			UI.messagebox("Restriccin de crecimiento vertical activada")
		end
		string = ""
		current = PracticaUtils.current_shape
		if execution.num_shapes || execution.up || execution.left
			string = "Restricciones activas: "
		end
		if  execution.num_shapes && execution.up && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal, crecimiento vertical" 
		elsif execution.num_shapes && execution.up
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento vertical" 
		elsif execution.num_shapes && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal" 
		elsif execution.num_shapes
			string += "nmero de piezas (#{execution.max_num_shapes})" 
		elsif execution.up && execution.left
			string += "crecimiento horizontal, crecimiento vertical" 
		elsif execution.up
			string += "crecimiento vertical" 
		elsif execution.left
			string += "crecimiento horizontal" 
		end
		execution.text.text = "Nmero de piezas = #{current.c.length}\n" + string
	}
	grow_up.tooltip = "Limita el crecimiento del axioma al plano vertical"
	grow_up.small_icon = File.join(Constants::ICONS_DIR, "updown.PNG")
	grow_up.large_icon = File.join(Constants::ICONS_DIR, "updown.PNG")
	toolbar.add_item grow_up
	
	grow_left = UI::Command.new("grow_left"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active
			
		if execution.left
			execution.left = false
			UI.messagebox("Restriccin de crecimiento horizontal desactivada")
		else
			execution.left = true
			UI.messagebox("Restriccin de crecimiento horizontal activada")
		end
		string = ""
		current = PracticaUtils.current_shape
		if execution.num_shapes || execution.up || execution.left
			string = "Restricciones activas: "
		end
		if  execution.num_shapes && execution.up && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal, crecimiento vertical" 
		elsif execution.num_shapes && execution.up
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento vertical" 
		elsif execution.num_shapes && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal" 
		elsif execution.num_shapes
			string += "nmero de piezas (#{execution.max_num_shapes})" 
		elsif execution.up && execution.left
			string += "crecimiento horizontal, crecimiento vertical" 
		elsif execution.up
			string += "crecimiento vertical" 
		elsif execution.left
			string += "crecimiento horizontal" 
		end
		execution.text.text = "Nmero de piezas = #{current.c.length}\n" + string
	}
	grow_left.tooltip = "Limita el crecimiento del axioma al plano horizontal"
	grow_left.small_icon = File.join(Constants::ICONS_DIR, "leftright.PNG")
	grow_left.large_icon = File.join(Constants::ICONS_DIR, "leftright.PNG")
	toolbar.add_item grow_left
	
	toolbar.add_separator
	
	# Save shape command
	save_shape_cmd = UI::Command.new("salvar_forma"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active
	
		save_shape_path = UI.savepanel "Guardar estructura", "", "estructura.txt"
		if save_shape_path
			if PracticaUtils.get_extension(save_shape_path) == "txt"
				begin
					execution.current_shape.save(save_shape_path)
					UI.messagebox("Su diseo se ha guardado con xito")
				rescue
					UI.messagebox("La ruta que ha elegido no es vlida")
				end
			else
				UI.messagebox("Para salvar el diseo debe elegir un archivo .txt")
			end
		end
	}
	save_shape_cmd.tooltip = "Guardar megaestructura"
	save_shape_cmd.small_icon = File.join(Constants::ICONS_DIR, "save_design.PNG")
	save_shape_cmd.large_icon = File.join(Constants::ICONS_DIR, "save_design.PNG")
	toolbar.add_item save_shape_cmd
	
	# Load shape command
	load_shape_cmd = UI::Command.new("cargar_forma"){
		project = Practica.project
		Sketchup.active_model.close_active
		execution = Practica.project.execution
		
		chosen_path = UI.openpanel("Cargar megaestructura", "" ,"*.txt")
		if chosen_path
			if PracticaUtils.get_extension(chosen_path) == "txt"
				File.open(chosen_path, 'r') do |f|
					line = f.gets
					line_a1 = line.split(":")
					if line_a1[0].include? "Type"
						type = line_a1[1]
						if type.include? "cube"
							Sketchup.active_model.entities.erase_entities execution.text
							max_rules = execution.grammar.rules.length
							cont = 0
							while cont < max_rules
								execution.grammar.rules[cont].erase
								cont+=1
							end
							PracticaUtils.current_shape.erase
							if execution.hill.painted
								PracticaUtils.hills.erase
							end
							if execution.pyramid.painted
								execution.pyramid.erase
							end
							PracticaUtils.create_project_cube ("face")
							execution = Practica.project.execution
							execution.current_shape.load(chosen_path)
							current = PracticaUtils.current_shape
							cont = 0
							find = false
							while (cont < current.c.length) && !find
								if current.c[cont].position.z == 0
									find = true
									execution.axiom = current.c[cont]
								end
								cont+=1
							end
							if !find
								execution.axiom = current.c[0]
							end
						elsif type.include? "triangle"
							Sketchup.active_model.entities.erase_entities execution.text
							max_rules = execution.grammar.rules.length
							cont = 0
							while cont < max_rules
								execution.grammar.rules[cont].erase
								cont+=1
							end
							PracticaUtils.current_shape.erase
							if execution.hill.painted
								PracticaUtils.hills.erase
							end
							if execution.pyramid.painted
								execution.pyramid.erase
							end
							PracticaUtils.create_project_triangularprism ("face")
							execution = Practica.project.execution
							execution.current_shape.load(chosen_path)
							current = PracticaUtils.current_shape
							cont = 0
							find = false
							while (cont < current.c.length) && !find
								if current.c[cont].position.z == 0
									find = true
									execution.axiom = current.c[cont]
								end
								cont+=1
							end
							if !find
								execution.axiom = current.c[0]
							endcont+=1
							end
						elsif type.include? "hexagonal"
							Sketchup.active_model.entities.erase_entities execution.text
							max_rules = execution.grammar.rules.length
							cont = 0
							while cont < max_rules
								execution.grammar.rules[cont].erase
								cont+=1
							end
							PracticaUtils.current_shape.erase
							if execution.hill.painted
								PracticaUtils.hills.erase
							end
							if execution.pyramid.painted
								execution.pyramid.erase
							end
							PracticaUtils.create_project_hexagonalprism  ("face")
							execution = Practica.project.execution
							execution.current_shape.load(chosen_path)
							current = PracticaUtils.current_shape
							cont = 0
							find = false
							while (cont < current.c.length) && !find
								if current.c[cont].position.z == 0
									find = true
									execution.axiom = current.c[cont]
								end
								cont+=1
							end
							if !find
								execution.axiom = current.c[0]
							end
						else
							UI.messagebox("El archivo no tiene la estructura interna deseada")
						end
					else
						UI.messagebox("El archivo no tiene la estructura interna deseada")
					end
				end
			end
		end
		string = ""
		current = PracticaUtils.current_shape
		if execution.num_shapes || execution.up || execution.left
			string = "Restricciones activas: "
		end
		if  execution.num_shapes && execution.up && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal, crecimiento vertical" 
		elsif execution.num_shapes && execution.up
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento vertical" 
		elsif execution.num_shapes && execution.left
			string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal" 
		elsif execution.num_shapes
			string += "nmero de piezas (#{execution.max_num_shapes})" 
		elsif execution.up && execution.left
			string += "crecimiento horizontal, crecimiento vertical" 
		elsif execution.up
			string += "crecimiento vertical" 
		elsif execution.left
			string += "crecimiento horizontal" 
		end
		execution.text.text = "Nmero de piezas = #{current.c.length}\n" + string
	}
	load_shape_cmd.tooltip = "Abrir una megaestructura"
	load_shape_cmd.small_icon = File.join(Constants::ICONS_DIR, "open_design.PNG")
	load_shape_cmd.large_icon = File.join(Constants::ICONS_DIR, "open_design.PNG")
	toolbar.add_item load_shape_cmd
	
	toolbar.add_separator
	
	# Tutorial
	tutorial = UI::Command.new("tutorial"){
		project = Practica.project
		execution = Practica.project.execution
		Sketchup.active_model.close_active
		
		# Find and show our html file
		html_path = Sketchup.find_support_file "Gramatica.html" ,Constants::HTML_DIR
		name_dialog = create_gramatica_dialog("Gramatica.html")
	        name_dialog.set_file(html_path)
	        name_dialog.show()
			
	}
	tutorial.tooltip = "Tutorial"
	tutorial.small_icon = File.join(Constants::ICONS_DIR, "tutorial.PNG")
	tutorial.large_icon = File.join(Constants::ICONS_DIR, "tutorial.PNG")
	toolbar.add_item tutorial
	
	toolbar.show
end

#Tool for adding a seed
class AddSeedsTool
	def initialize 
	    # The Sketchup::InputPoint class is used to get 3D points from screen
	    # positions.  It uses the SketchUp inferencing code.
	    # In this tool, we will have one points
	    @ip = Sketchup::InputPoint.new
	end
    
	#Activates the cursor
	def activate
		file_name = Sketchup.find_support_file "add_seed.png", "Plugins/Practica/#{Constants::ABS_ICONS_DIR}"
		@id_cursor = UI.create_cursor file_name, 18, 18
	end
	
	#Method that triggers when the cursor is chosen
	def onSetCursor
		UI.set_cursor  @id_cursor
	end
	
	#Method that triggers when the left button of the mouse is pressed
	def onLButtonDown(flags, x, y, view)

		inputpoint = view.inputpoint x,y
		point = inputpoint.position
		execution = Practica.project.execution
		current_shape = PracticaUtils.current_shape
		
		#We check if the point is in the valid area
		solution = false
		if ((point.x >= Constants::PTS_H1[0][0])&&(point.y >= Constants::PTS_H2[1][1]))
			if ( point.x <= Constants::PTS_H2[1][0])
				if (point.y <= Constants::PTS_H1[0][1])
					solution = true
				end
			end
		end
		if !solution
			UI.messagebox("El punto debe estar dentro del rea")
		else
			if current_shape.type.include? "cube"
				size = Constants::SIZE
				height = Constants::SIZE
			elsif current_shape.type.include? "triangle"
				size = Constants::SIZE
				height = Constants::HEIGHT_T
			elsif current_shape.type.include? "hexagonal"
				size = Constants::SIZE_H + Constants::SIZE_H/2
				height = 2*Constants::APOTEMA
			end
			if point.x < (Constants::PTS_H1[0][0] + size)
				if current_shape.type.include? "hexagonal"
					point.x = point.x + size
				end
			end
			if point.x > (Constants::PTS_H1[1][0] - size)
				point.x = point.x - size
			end
			if point.y < (Constants::PTS_H2[1][1] + height)
				point.y = point.y + height/2
			end
			if point.y > (Constants::PTS_H1[1][1] - height - height/2)
				if current_shape.type.include? "triangle"
					point.y = point.y - height - height/2
				else
					point.y = point.y - height 
				end
			end
			new_z = (point.z/Constants::HEIGHT_S).round
			z = new_z * Constants::HEIGHT_S
			equal = false
			equal_h = false
			if point.x - Constants::PTS_H1[0][0] + size/2 <= Constants::VECTOR_INTERSECTION_HILL[0][0]
				i = (Constants::VECTOR_INTERSECTION_HILL[0][0] - point.x + Constants::PTS_H1[0][0]).to_m.m
				new_x = (i / size).round
				x = -(new_x*size.to_m)
				if  point.y - Constants::PTS_H2[0][1] + height/2 < Constants::VECTOR_INTERSECTION_HILL[0][1]
					i = (Constants::VECTOR_INTERSECTION_HILL[0][1] - (point.y - Constants::PTS_H2[0][1])).to_m.m
					new_y = (i / height).round
					y = -(new_y*height.to_m)
					if current_shape.type.include? "triangle"
						if new_y%2 != 0
							x_1 = x + (size/2).to_m
							x_2 = x - (size/2).to_m
							if (new_x-x_1).abs < (new_x-x_2).abs
								x = x_1
							elsif (new_x-x_1).abs > (new_x-x_2).abs
								x = x_2
							else
								equal = true
							end
						end
					elsif current_shape.type.include? "hexagonal"
						if new_x%2 != 0
							y_1 = y + (height/2).to_m
							y_2 = y - (height/2).to_m
							if (new_y-y_1).abs < (new_y-y_2).abs
								y = y_1
							elsif (new_y-y_1).abs > (new_y-y_2).abs
								y = y_2
							else
								equal_h = true
							end
						end
					end
				else
					i = (-Constants::VECTOR_INTERSECTION_HILL[0][1] + (point.y - Constants::PTS_H2[0][1])).to_m.m
					new_y = (i / height).round
					y = (new_y*height.to_m)
					if current_shape.type.include? "triangle"
						if new_y%2 != 0
							x_1 = x + (size/2).to_m
							x_2 = x - (size/2).to_m
							if (new_x-x_1).abs < (new_x-x_2).abs
								x = x_1
							elsif (new_x-x_1).abs > (new_x-x_2).abs
								x = x_2
							else
								equal = true
							end
						end
					elsif current_shape.type.include? "hexagonal"
						if new_x%2 != 0
							y_1 = y + (height/2).to_m
							y_2 = y - (height/2).to_m
							if (new_y-y_1).abs < (new_y-y_2).abs
								y = y_1
							elsif (new_y-y_1).abs > (new_y-y_2).abs
								y = y_2
							else
								equal_h = true
							end
						end
					end
				end
			else
				i = (-Constants::VECTOR_INTERSECTION_HILL[0][0] + point.x - Constants::PTS_H1[0][0]).to_m.m
				new_x = (i / size).round
				x = (new_x*size.to_m)
				if  point.y - Constants::PTS_H2[0][1] + height/2 < Constants::VECTOR_INTERSECTION_HILL[0][1]
					i = (Constants::VECTOR_INTERSECTION_HILL[0][1] - (point.y - Constants::PTS_H2[0][1])).to_m.m
					new_y = (i / height).round
					y = -(new_y*height.to_m)
					if current_shape.type.include? "triangle"
						if new_y%2 != 0
							x_1 = x + (size/2).to_m
							x_2 = x - (size/2).to_m
							if (new_x-x_1).abs > (new_x-x_2).abs
								x = x_2
							elsif (new_x-x_1).abs < (new_x-x_2).abs
								x = x_1
							else
								equal = true
							end
						end
					elsif current_shape.type.include? "hexagonal"
						if new_x%2 != 0
							y_1 = y + (height/2).to_m
							y_2 = y - (height/2).to_m
							if (new_y-y_1).abs > (new_y-y_2).abs
								y = y_2
							elsif (new_y-y_1).abs < (new_y-y_2).abs
								y = y_1
							else
								equal_h = true
							end
						end
					end
				else
					i = (-Constants::VECTOR_INTERSECTION_HILL[0][1] + (point.y - Constants::PTS_H2[0][1])).to_m.m
					new_y = (i / height).round
					y = (new_y*height.to_m)
					if current_shape.type.include? "triangle"
						if new_y%2 != 0
							x_1 = x + (size/2).to_m
							x_2 = x - (size/2).to_m
							if (new_x-x_1).abs > (new_x-x_2).abs
								x = x_2
							elsif (new_x-x_1).abs < (new_x-x_2).abs
								x = x_1
							else
								equal = true
							end
						end
					elsif current_shape.type.include? "hexagonal"
						if new_x%2 != 0
							y_1 = y + (height/2).to_m
							y_2 = y - (height/2).to_m
							if (new_y-y_1).abs > (new_y-y_2).abs
								y = y_2
							elsif (new_y-y_1).abs < (new_y-y_2).abs
								y = y_1
							else
								equal_h = true
							end
						end
					end
				end
			end
			new_point = OrderedPoint.new(Geom::Point3d.new(x.m, y.m, z.to_m.m))
			if equal == true
				p1= OrderedPoint.new(Geom::Point3d.new(x_1.m, y.m, z.to_m.m))
				p2 = OrderedPoint.new(Geom::Point3d.new(x_2.m, y.m, z.to_m.m))
				if current_shape.esta_pos(p1)
					new_point = p2
				else
					new_point = p1
				end
			end
			if equal_h == true
				p1= OrderedPoint.new(Geom::Point3d.new(x.m, y_1.m, z.to_m.m))
				p2 = OrderedPoint.new(Geom::Point3d.new(x.m, y_2.m, z.to_m.m))
				if current_shape.esta_pos(p1)
					new_point = p2
				else
					new_point = p1
				end
			end
			if current_shape.type.include? "cube"
				cube = Cube.new(Constants::SIZE)
				candidate = (PositionCube.new(cube, new_point))
			elsif current_shape.type.include? "triangle"
				prism = TriangularPrism.new(Constants::SIZE)
				candidate = (PositionTriangularPrism.new(prism, new_point, false))
			elsif current_shape.type.include? "hexagonal"
				prism = HexagonalPrism.new(Constants::SIZE_H)
				candidate = (PositionHexagonalPrism.new(prism, new_point))
			end
			execution.teste_candidate_intersection (candidate)
			
			string = ""
			current = PracticaUtils.current_shape
			if execution.num_shapes || execution.up || execution.left
				string = "Restricciones activas: "
			end
			if  execution.num_shapes && execution.up && execution.left
				string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal, crecimiento vertical" 
			elsif execution.num_shapes && execution.up
				string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento vertical" 
			elsif execution.num_shapes && execution.left
				string += "nmero de piezas (#{execution.max_num_shapes}), crecimiento horizontal" 
			elsif execution.num_shapes
				string += "nmero de piezas (#{execution.max_num_shapes})" 
			elsif execution.up && execution.left
				string += "crecimiento horizontal, crecimiento vertical" 
			elsif execution.up
				string += "crecimiento vertical" 
			elsif execution.left
				string += "crecimiento horizontal" 
			end
			execution.text.text = "Nmero de piezas = #{current.c.length}\n" + string
		end
	end
end

#Tool for moving a seed or the axiom
class MoveSeedTool
	def initialize
	    # The Sketchup::InputPoint class is used to get 3D points from screen
	    # positions.  It uses the SketchUp inferencing code.
	    # In this tool, we will have one points
	    @ip = Sketchup::InputPoint.new
	end
    
	#Activates the cursor
	def activate
		file_name = Sketchup.find_support_file "move_seed.png", "Plugins/Practica/#{Constants::ABS_ICONS_DIR}"
		@id_cursor = UI.create_cursor file_name, 18, 18
	end
	
	#Method that triggers when the cursor is chosen
	def onSetCursor
		UI.set_cursor  @id_cursor
	end
	
	#Method that triggers when the left button of the mouse is pressed
	def onLButtonDown(flags, x, y, view)

		inputpoint = view.inputpoint x,y
		point = inputpoint.position
		
		execution = Practica.project.execution
		current_shape = PracticaUtils.current_shape
		if execution.apply_r
			UI.messagebox("Si ya ha aplicado una regla no puede mover una semilla de sitio")
		else
			#We check if the point is in the valid area
			solution = false
			if ((point.x >= Constants::PTS_H1[0][0])&&(point.y >= Constants::PTS_H2[1][1]))
				if ( point.x <= Constants::PTS_H2[1][0])
					if (point.y <= Constants::PTS_H1[0][1])
						solution = true
					end
				end
			end
			if !solution
				UI.messagebox("El punto debe estar dentro del rea")
			else
				if current_shape.type.include? "cube"
					size = current_shape.c[0].cube.size
					height = current_shape.c[0].cube.size
				elsif current_shape.type.include? "triangle"
					size = current_shape.c[0].prism.size
					height = Constants::HEIGHT_T
				elsif current_shape.type.include? "hexagonal"
					size = current_shape.c[0].prism.size + current_shape.c[0].prism.size/2
					height = 2*Constants::APOTEMA
				end
				if point.x < (Constants::PTS_H1[0][0] + size)
					if current_shape.type.include? "hexagonal"
						point.x = point.x + size
					end
				end
				if point.x > (Constants::PTS_H1[1][0] - size)
					point.x = point.x - size
				end
				if point.y < (Constants::PTS_H2[1][1] + height)
					point.y = point.y + height/2
				end
				if point.y > (Constants::PTS_H1[1][1] - height - height/2)
					if current_shape.type.include? "triangle"
						point.y = point.y - height - height/2
					else
						point.y = point.y - height 
					end
				end
				equal = false
				equal_h = false
				new_z = (point.z/Constants::HEIGHT_S).round
				z = new_z * Constants::HEIGHT_S
				if point.x - Constants::PTS_H1[0][0] + size/2 <= Constants::VECTOR_INTERSECTION_HILL[0][0]
					i = (Constants::VECTOR_INTERSECTION_HILL[0][0] - point.x + Constants::PTS_H1[0][0]).to_m.m
					new_x = (i / size).round
					x = -(new_x*size.to_m)
					if  point.y - Constants::PTS_H2[0][1] + height/2 < Constants::VECTOR_INTERSECTION_HILL[0][1]
						i = (Constants::VECTOR_INTERSECTION_HILL[0][1] - (point.y - Constants::PTS_H2[0][1])).to_m.m
						new_y = (i / height).round
						y = -(new_y*height.to_m)
						if current_shape.type.include? "triangle"
							if new_y%2 != 0
								x_1 = x + (size/2).to_m
								x_2 = x - (size/2).to_m
								if (new_x-x_1).abs < (new_x-x_2).abs
									x = x_1
								elsif (new_x-x_1).abs > (new_x-x_2).abs
									x = x_2
								else
									equal = true
								end
							end
						elsif current_shape.type.include? "hexagonal"
							if new_x%2 != 0
								y_1 = y + (height/2).to_m
								y_2 = y - (height/2).to_m
								if (new_y-y_1).abs < (new_y-y_2).abs
									y = y_1
								elsif (new_y-y_1).abs > (new_y-y_2).abs
									y = y_2
								else
									equal_h = true
								end
							end
						end
					else
						i = (-Constants::VECTOR_INTERSECTION_HILL[0][1] + (point.y - Constants::PTS_H2[0][1])).to_m.m
						new_y = (i / height).round
						y = (new_y*height.to_m)
						if current_shape.type.include? "triangle"
							if new_y%2 != 0
								x_1 = x + (size/2).to_m
								x_2 = x - (size/2).to_m
								if (new_x-x_1).abs < (new_x-x_2).abs
									x = x_1
								elsif (new_x-x_1).abs > (new_x-x_2).abs
									x = x_2
								else
									equal = true
								end
							end
						elsif current_shape.type.include? "hexagonal"
							if new_x%2 != 0
								y_1 = y + (height/2).to_m
								y_2 = y - (height/2).to_m
								if (new_y-y_1).abs < (new_y-y_2).abs
									y = y_1
								elsif (new_y-y_1).abs > (new_y-y_2).abs
									y = y_2
								else
									equal_h = true
								end
							end
						end
					end
				else
					i = (-Constants::VECTOR_INTERSECTION_HILL[0][0] + point.x - Constants::PTS_H1[0][0]).to_m.m
					new_x = (i / size).round
					x = (new_x*size.to_m)
					if  point.y - Constants::PTS_H2[0][1] + height/2 < Constants::VECTOR_INTERSECTION_HILL[0][1]
						i = (Constants::VECTOR_INTERSECTION_HILL[0][1] - (point.y - Constants::PTS_H2[0][1])).to_m.m
						new_y = (i / height).round
						y = -(new_y*height.to_m)
						if current_shape.type.include? "triangle"
							if new_y%2 != 0
								x_1 = x + (size/2).to_m
								x_2 = x - (size/2).to_m
								if (new_x-x_1).abs < (new_x-x_2).abs
									x = x_1
								elsif (new_x-x_1).abs > (new_x-x_2).abs
									x = x_2
								else
									equal = true
								end
							end
						elsif current_shape.type.include? "hexagonal"
							if new_x%2 != 0
								y_1 = y + (height/2).to_m
								y_2 = y - (height/2).to_m
								if (new_y-y_1).abs < (new_y-y_2).abs
									y = y_1
								elsif (new_y-y_1).abs > (new_y-y_2).abs
									y = y_2
								else
									equal_h = true
								end
							end
						end
					else
						i = (-Constants::VECTOR_INTERSECTION_HILL[0][1] + (point.y - Constants::PTS_H2[0][1])).to_m.m
						new_y = (i / height).round
						y = (new_y*height.to_m)
						if current_shape.type.include? "triangle"
							if new_y%2 != 0
								x_1 = x + (size/2).to_m
								x_2 = x - (size/2).to_m
								if (new_x-x_1).abs < (new_x-x_2).abs
									x = x_1
								elsif (new_x-x_1).abs > (new_x-x_2).abs
									x = x_2
								else
									equal = true
								end
							end
						elsif current_shape.type.include? "hexagonal"
							if new_x%2 != 0
								y_1 = y + (height/2).to_m
								y_2 = y - (height/2).to_m
								if (new_y-y_1).abs < (new_y-y_2).abs
									y = y_1
								elsif (new_y-y_1).abs > (new_y-y_2).abs
									y = y_2
								else
									equal_h = true
								end
							end
						end
					end
				end
				new_point = OrderedPoint.new(Geom::Point3d.new(x.m, y.m, z.to_m.m))
				if equal == true
					p1= OrderedPoint.new(Geom::Point3d.new(x_1.m, y.m, z.to_m.m))
					p2 = OrderedPoint.new(Geom::Point3d.new(x_2.m, y.m, z.to_m.m))
					if current_shape.esta_pos(p1)
						new_point = p2
					else
						new_point = p1
					end
				end
				if equal_h == true
					p1= OrderedPoint.new(Geom::Point3d.new(x.m, y_1.m, z.to_m.m))
					p2 = OrderedPoint.new(Geom::Point3d.new(x.m, y_2.m, z.to_m.m))
					if current_shape.esta_pos(p1)
						new_point = p2
					else
						new_point = p1
					end
				end
				if current_shape.type.include? "cube"
					candidate = (PositionCube.new(current_shape.c[0].cube.duplicate, new_point))
				elsif current_shape.type.include? "triangle"
					candidate = (PositionTriangularPrism.new(current_shape.c[0].prism.duplicate, new_point, false))
				elsif current_shape.type.include? "hexagonal"
					candidate = (PositionHexagonalPrism.new(current_shape.c[0].prism.duplicate, new_point))
				end
				selection = Sketchup.active_model.selection
				if !selection.empty?
					
					 # Look at all of the entities in the selection.
					current = PracticaUtils.current_shape
					current.c.sort! { |shape1, shape2|
						shape1.position <=> shape2.position
					}
					cont = 0
					max = current.c.length
					esta = false
					while (cont < max)&&(!esta)
						if current.type.include? "cube"
							if selection.contains? current.c[cont].cube.group
								if current.c[cont].position != execution.axiom.position
									esta = true
								end
							end
							if !esta
								cont+=1
							end
						else
							if selection.contains? current.c[cont].prism.group
								if current.c[cont].position != execution.axiom.position
									esta = true
								end
							end
							if !esta
								cont+=1
							end
						end
					end
					if esta
						execution.move_seed(candidate, cont)
					else
						execution.move_axiom(candidate)
					end
				else
					execution.move_axiom(candidate)
				end
			end
		end
	end
end