require 'sketchup' 
require 'Practica//lib//structures.rb'
require 'Practica//lib//m-structures.rb'

#This class holds the constants used along the application
class Constants
	# Initial Points for the horizontal line
	PTS_H = []
	PTS_H[0] = [-100.0.m,-1.m,0.m]
	PTS_H[1] = [5.0.m,-1.m,0.m]
	
	# Initial Points for the horizontal line
	PTS_H1 = []
	PTS_H1[0] = [5.0.m,10.0.m,0.m]
	PTS_H1[1] = [105.0.m,10.0.m,0.m]
	
	# Initial Points for the horizontal line
	PTS_H2 = []
	PTS_H2[0] = [5.0.m,-90.0.m,0.m]
	PTS_H2[1] = [105.0.m,-90.0.m,0.m]
	
	#Vector which helps us to put the axiom in the canvas
	VECTOR_TRANSLATION_AXIOM = []
	#VECTOR_TRANSLATION_AXIOM[0] = [95.0.m,-4.m,0.m]
	VECTOR_TRANSLATION_AXIOM[0] =  [53.5.m,-41.5.m,3.m]
	
	#Vector which helps us to put the hills in the canvas
	VECTOR_TRANSLATION_HILL = []
	VECTOR_TRANSLATION_HILL[0] =  [5.0.m,-90.m,0.m]
	
	#Vector which helps us to check intersections
	VECTOR_INTERSECTION_HILL = []
	VECTOR_INTERSECTION_HILL[0] =  [ 48.5.m,48.5.m,0.m]
	VECTOR_INTERSECTION_HILL[1] =  [ 48.5.m,48.5.m,3.m]

		
	# Points for the vertical line
	PTS_V = []
	PTS_V[0] = [5.0.m,10.0.m,0.m]
	PTS_V[1] = [5.0.m,-90.0.m,0.m]
	
	# Points for the canvas
	PTS_V1 = []
	PTS_V1[0] = [105.0.m,10.0.m,0.m]
	PTS_V1[1] = [105.0.m,-90.0.m,0.m]
	
	# Initial Points for the arrows
	PTS_ARROW = []
	PTS_ARROW[0] = [-5.8.m, 3.4.m, 3.m]
	PTS_ARROW[1] = [-4.8.m, 3.4.m, 3.m]
	PTS_ARROW[2] = [-5.3.m, 3.8.m, 3.m]
	PTS_ARROW[3] = [-5.3.m, 3.m, 3.m]
	
	
	
	vector_translation = Geom::Vector3d.new -10.m,2.m,3.m
	# Default transformation for the left side of the rules
	LEFT_T = Geom::Transformation.translation vector_translation
		
	vector_translation = Geom::Vector3d.new -4.m,2.m,3.m
	# Default transformation for the right (without additive) side of the rules
	RIGHT_T = Geom::Transformation.translation vector_translation
	
	vector_translation = Geom::Vector3d.new 0.m,-10.6.m,0.m
	# Iterative transformation for the rule elements, in order to descend along the screen
	DESCEND_T = Geom::Transformation.translation vector_translation
	
	vector_translation = Geom::Vector3d.new 53.5.m,-41.5.m,3.m
	# Transformation for the axiom of the grammar
	AXIOM_T = Geom::Transformation.translation vector_translation
	
	vector_translation = Geom::Vector3d.new 5.0.m,-90.m,0.m
	# Transformation for hills
	HILL_T = Geom::Transformation.translation vector_translation
	
	vector_translation = Geom::Vector3d.new 48.5.m,48.5.m,3.m
	#Transformation which helps us to check intersections
	INTERSECTION = Geom::Transformation.translation vector_translation
	
	#Initial height of the camera
	INITIAL_Z_CAMERA = 200.m
	
	#Default size of the shapes (cube and triangle prism)
	SIZE = 3.m
	
	#Default size of the hexagonal prism
	SIZE_H = 1.548.m
	
	#Default height of the shapes
	HEIGHT_S = 3.m
	
	#Default radio for the triangle prism
	RADIO = (1 / Math.sqrt(3)).m
	
	#Default triangle height
	HEIGHT_T = ((Math.sqrt(3)/2)*3).m
	
	#Default height pyramide
	HEIGHT_P = (Math.tan(Math::PI/6)*50).m
	
	#Default Vector height pyramide
	VECTOR_HEIGHT_PYRAMIDE = []
	VECTOR_HEIGHT_PYRAMIDE[0] = [55.m, -40.m, HEIGHT_P]
	
	#Pyramid angle
	ALFA = Math.tan(Math::PI/6)
	
	#Default pyramid size
	SIZE_P = 100.m
	
	#Maximum number of shapes in our design
	NUM_SHAPES =800
	
	POINT_INFORMATION = []
	POINT_INFORMATION[0] = [-55.m, -90.m, 0]
	
	
	#Hexagonal Apotema
	APOTEMA = Math.sqrt(1.622304).m
	
	# Project default title
	DEFAULT_PROJECT_TITLE = "Untitled"
	
	# Default relative (to guitools.rb) Icons directory
	ICONS_DIR = "../resources/shade_icons"
	
	# Default absolute Icons directory
	ABS_ICONS_DIR = "lib/resources/shade_icons"
	
	# Static Toolbar name
	STATIC_TOOLBAR_NAME = "Practica - Barra de edicion"
	
	# Default html dialogs directory
	HTML_DIR = "Plugins//Practica//lib//interfaces//html"
end

#Utils class
class PracticaUtils
	
	#Prepares the canvas for the plugin
	def PracticaUtils.prepare_canvas()
		# Prepare view
		Sketchup.send_action("viewTop:")
		Sketchup.send_action("viewShowAxes:")
		# Center view 
		eye = [Constants::PTS_H[1][0], -100, Constants::INITIAL_Z_CAMERA]
		target = Constants::PTS_H[1]
		up = Sketchup.active_model.active_view.camera.up
		Sketchup.active_model.active_view.camera.set eye, target, up
			
		# Draw vertical line
		point1 = Constants::PTS_V[0].clone
		point2 = Constants::PTS_V[1].clone
		group = Sketchup.active_model.entities.add_group
		group.entities.add_line point1,point2
		point11 = Constants::PTS_V1[0].clone
		point21 = Constants::PTS_V1[1].clone
		group.entities.add_line point11,point21
		point3 = Constants::PTS_H1[0].clone
		point4 = Constants::PTS_H1[1].clone
		group.entities.add_line point3,point4
		point5 = Constants::PTS_H2[0].clone
		point6 = Constants::PTS_H2[1].clone
		group.entities.add_line point5,point6
	end
	
	#returns:: a default axiom
	def PracticaUtils.create_default_axiom(shape)
		axiom = shape
		return axiom
	end
	
	#returns: a default cube axiom for the rules
	def PracticaUtils.create_current_shape_cube(shape)
		position = OrderedPoint.new(Geom::Point3d.new(0,0,0))
		current_shape = CubeShape.new(shape, position)
		current_shape.repaint
		return current_shape
	end
	
	#returns: a default triangular prism axiom for the rules
	def PracticaUtils.create_current_shape_triangularPrism(shape)
		position = OrderedPoint.new(Geom::Point3d.new(0,0,0))
		current_shape = TriangularPrismShape.new(shape, position, false)
		current_shape.repaint
		return current_shape
	end
	
	#returns: a default hexagonal prism axiom for the rules
	def PracticaUtils.create_current_shape_hexagonalPrism(shape)
		position = OrderedPoint.new(Geom::Point3d.new(0,0,0))
		current_shape = HexagonalPrismShape.new(shape, position)
		current_shape.repaint
		return current_shape
	end
	
	#id:: an id
	#shape:: an objet that represents the shape that the grammar uses (cube, triangular prism or hexagonal prism)
	#t_rule:: the transformation that we need to paint the shape on the rigth side of the rule
	#type_rule:: each shape  has its own rules
	#
	#Paint a rule
	def PracticaUtils.paint_rule(id, shape, t_rule, type_rule)
		execution = Practica.project.execution
		
		previous_rule = execution.grammar.search_rule_by_id(id)
		if execution.grammar
			idx = execution.grammar.rules.size 
		else
			idx = 0
		end
		t = idx

		# Transform the layout transformation of the shapes
		t_left = Geom::Transformation.new
		t_right = Geom::Transformation.new
		t.times do
			t_left = Constants::DESCEND_T * t_left
			t_right = Constants::DESCEND_T * t_right
		end
		t_left = Constants::LEFT_T * t_left
		t_right = Constants::RIGHT_T * t_right
		
		shape.paint(t_left)
		
		# Draw an arrow, for the rule
		point1 = Constants::PTS_ARROW[0].clone
		point2 = Constants::PTS_ARROW[1].clone
		point3 = Constants::PTS_ARROW[2].clone
		point4 = Constants::PTS_ARROW[3].clone
				
		t.times do
			point1.transform! Constants::DESCEND_T 
			point2.transform! Constants::DESCEND_T 
			point3.transform! Constants::DESCEND_T 
			point4.transform! Constants::DESCEND_T 
		end

		group_arrow = Sketchup.active_model.entities.add_group
		group_arrow.entities.add_line point1, point2
		group_arrow.entities.add_line point3, point2
		group_arrow.entities.add_line point4, point2
		
		t_rule_final = t_right* t_rule
		shape_l = shape.duplicate
		shape_l.paint(t_right)
		shape_rule = shape_l.duplicate
		if shape.type.include? "triangle"
			shape_rule.paint(t_rule_final)
			if ((type_rule == "face2")||(type_rule == "edge2")||(type_rule == "point2")||(type_rule == "edge3"))
				vector = Geom::Vector3d.new(1,0,0)
				transformation = Geom::Transformation.rotation t_rule_final, vector, Math::PI
				shape_rule.group.transform! transformation
			end
			
		else
			shape_rule.paint(t_rule_final)
		end
		
		#Paint a horizontal line
		point_h1 = Constants::PTS_H[0].clone
		point_h2 = Constants::PTS_H[1].clone
				
		t.times do
			point_h1.transform! Constants::DESCEND_T 
			point_h2.transform! Constants::DESCEND_T 
		end
		line_group = Sketchup.active_model.entities.add_group
		line_group.entities.add_line point_h1,point_h2
		
		#Create the new rule
		new_rule = Rules.new(id, shape, type_rule, group_arrow, line_group, shape_l, shape_rule)
		
		return new_rule
		
	end
	
	#type_transformation:: the rule that the project has.
	#
	#Creates a new project where the main shape is a cube
	def PracticaUtils.create_project_cube(type_transformation)
		# Create the grammar
		grammar = Grammar.new
		# Create the execution
		execution = Execution.new(grammar, nil)
		# Create the project
		project = Project.new(execution)
		
		#Add the project to Shade
		Practica.project = project
		#The default project contains a cube
		cube = Cube.new(Constants::SIZE)
		#We need a transformation to paint a rule
		if type_transformation == "face"
			t_rule = Geom::Transformation.new
			t_rule = [cube.size,0,0]
		elsif type_transformation == "point"
			t_rule = Geom::Transformation.new
			t_rule = [cube.size,cube.size,-cube.size]
		elsif type_transformation == "edge"
			t_rule = Geom::Transformation.new
			t_rule = [cube.size,cube.size,0]
		end
		# Create the first rule
		rule = PracticaUtils.paint_rule(1, cube, t_rule, type_transformation)
		# Add rule to the grammar
		grammar.add_rule rule
		# Associate the grammar with the execution
		execution.grammar = grammar
		#Create the axiom
		cube2 = Cube.new(Constants::SIZE)
		execution.grammar.axiom = create_default_axiom(cube2)
		execution.current_shape = create_current_shape_cube(cube2)
	end
	
	#type_transformation:: the rule that the project has.
	#
	#Creates a new project where the main shape is a triangular prism
	def PracticaUtils.create_project_triangularprism(type_transformation)
		# Create the grammar
		grammar = Grammar.new
		# Create the execution
		execution = Execution.new(grammar, nil)
		# Create the project
		project = Project.new(execution)
		
		#Add the project to Shade
		Practica.project = project
	
		#The default project contains a cube
		prism = TriangularPrism.new(Constants::SIZE)
		#We need a transformation to paint a rule
		if type_transformation == "face2"
			t_rule = Geom::Transformation.new
			t_rule = [Constants::SIZE/2,Constants::HEIGHT_T,-Constants::HEIGHT_S] 
		elsif type_transformation == "face"
			t_rule = Geom::Transformation.new
			t_rule = [0,0,-prism.size]
		elsif type_transformation == "edge2"
			t_rule = Geom::Transformation.new
			t_rule = [Constants::SIZE/2,Constants::HEIGHT_T,-2*Constants::HEIGHT_S] 
		elsif type_transformation == "edge"
			t_rule = Geom::Transformation.new
			t_rule = [prism.size,0,0]
		elsif type_transformation == "point2"
			t_rule = Geom::Transformation.new
			t_rule = [Constants::SIZE,0,-2*Constants::HEIGHT_S] 
		elsif type_transformation == "edge3"
			t_rule = Geom::Transformation.new
			t_rule = [Constants::SIZE,0,-Constants::HEIGHT_S] 
		elsif type_transformation == "point"
			t_rule = Geom::Transformation.new
			t_rule = [Constants::SIZE,0,-Constants::HEIGHT_S] 
		end
		# Create the first rule
		rule = PracticaUtils.paint_rule(1, prism, t_rule, type_transformation)
		# Add rule to the grammar
		grammar.add_rule rule
		# Associate the grammar with the execution
		execution.grammar = grammar
		#Create the axiom
		prism2 = TriangularPrism.new(Constants::SIZE)
		execution.grammar.axiom = create_default_axiom(prism2)
		execution.current_shape = create_current_shape_triangularPrism(prism2)
	end
	
	#type_transformation:: the rule that the project has.
	#
	#Creates a new project where the main shape is an hexagonal prism
	def PracticaUtils.create_project_hexagonalprism(type_transformation)
		# Create the grammar
		grammar = Grammar.new
		# Create the execution
		execution = Execution.new(grammar, nil)
		# Create the project
		project = Project.new(execution)
		
		#Add the project to Shade
		Practica.project = project
	
		#The default project contains a cube
		prism = HexagonalPrism.new(Constants::SIZE_H)
		#We need a transformation to paint a rule
		if type_transformation == "face2"
			t_rule = Geom::Transformation.new
			t_rule = [prism.size+prism.size/2,-Constants::APOTEMA,0] 
		elsif type_transformation == "face"
			t_rule = Geom::Transformation.new
			t_rule = [0,0,-Constants::HEIGHT_S]
		elsif type_transformation == "edge2"
			t_rule = Geom::Transformation.new
			t_rule = [2*prism.size, 0,0] 
		elsif type_transformation == "edge"
			t_rule = Geom::Transformation.new
			t_rule = [prism.size+prism.size/2,Constants::APOTEMA,-Constants::HEIGHT_S]
		elsif type_transformation == "point"
			t_rule = Geom::Transformation.new
			t_rule = [2*prism.size,0,-Constants::HEIGHT_S] 
		end
		# Create the first rule
		rule = PracticaUtils.paint_rule(1, prism, t_rule, type_transformation)
		# Add rule to the grammar
		grammar.add_rule rule
		# Associate the grammar with the execution
		execution.grammar = grammar
		#Create the axiom
		prism2 = HexagonalPrism.new(Constants::SIZE_H)
		execution.grammar.axiom = create_default_axiom(prism2)
		execution.current_shape = create_current_shape_hexagonalPrism(prism2)
	end
	
	#returns: a String object with a list of the present rule IDs, for example, if there are four rules: "1|2|3|4"
	def PracticaUtils.create_rule_list()
		execution = Practica.project.execution
		rule_list = ""
		rules_size = execution.grammar.rules.size
		rules_size.times do |s|
			if (s+1) == rules_size
				rule_list = "#{rule_list}#{s+1}"
			else
				rule_list = "#{rule_list}#{s+1}|"
			end
		end
		return rule_list
	end
	
	#returns:: the current shape
	def PracticaUtils.current_shape()
		return Practica.project.execution.current_shape
	end
	
	#returns:: the countour line map
	def PracticaUtils.hills()
		return Practica.project.execution.hill
	end
	
	#path:: a String representing a path of a file inside the system
	#
	#returns:: the extension of the file represented by the path
	def PracticaUtils.get_extension(path)
		if path.rindex(".")
			i = path.rindex(".") + 1
			j = (path.length) -1
			return path[i..j]
		else
			return nil
		end
	end
end

